/* CurrentTimeForm.cls */

USING Infragistics.Win.Misc.* FROM ASSEMBLY.
USING System.Windows.Forms.* FROM ASSEMBLY.

CLASS CurrentTimeForm INHERITS Progress.Windows.Form: 

  /* Variables for controls on form */
  DEFINE PRIVATE VARIABLE rTimeButton AS CLASS UltraButton NO-UNDO.
  DEFINE PRIVATE VARIABLE rCloseButton AS CLASS UltraButton NO-UNDO.
  DEFINE PRIVATE VARIABLE rDateField AS CLASS UltraLabel NO-UNDO.
  DEFINE PRIVATE VARIABLE dtNow AS DATETIME NO-UNDO.
  
  /* Public properties and methods */
  METHOD PUBLIC VOID DoWait( ):
    WAIT-FOR Application:Run( THIS-OBJECT ).
  END METHOD.

  /* Constructor and destructor */
  CONSTRUCTOR PUBLIC CurrentTimeForm( ):    
    InitializeComponent( ).
  END CONSTRUCTOR.
  
  /* Private form initialization method */
  METHOD PRIVATE VOID InitializeComponent( ):
  
    /* Creates base form class and all components */
    rTimeButton = NEW UltraButton( ).
    rCloseButton = NEW UltraButton( ).
    rDateField = NEW UltraLabel( ).
    
    THIS-OBJECT:SuspendLayout( ).
    
    /* Initialize current date/time field */
    dtNow = NOW.
    rDateField:Text = STRING(dtNow).
    rDateField:Size = TextRenderer:MeasureText( rDateField:Text, 
                                                rDateField:Font ).
    rDateField:Top = 20.
    
    /* Initialize the Time button */
    rTimeButton:Text = "Time".
    rTimeButton:Size = TextRenderer:MeasureText( rTimeButton:Text, 
                                                 rTimeButton:Font ).
    rTimeButton:Height = rTimeButton:Height * 2.
    rTimeButton:Width = rTimeButton:Width + 12.
    rTimeButton:Top = rDateField:Top + rDateField:Height + 10.
    rTimeButton:Click:Subscribe( TimeButton_Click ).
    
    /* Initialize the Close button */
    rCloseButton:Text = "Close".
    rCloseButton:Size = TextRenderer:MeasureText( rCloseButton:Text, 
                                                  rCloseButton:Font ).
    rCloseButton:Height = rTimeButton:Height.
    rCloseButton:Width = rCloseButton:Width + 12.
    rCloseButton:Top = rTimeButton:Top.
    rCloseButton:Click:Subscribe( CloseButton_Click ).
    
    /* Initialize the form with its field and buttons */
    THIS-OBJECT:Text = "Current Date and Time".
    THIS-OBJECT:FormBorderStyle = FormBorderStyle:FixedSingle.
    THIS-OBJECT:MaximizeBox = FALSE.
    THIS-OBJECT:Controls:Add( rDateField ).
    THIS-OBJECT:Controls:Add( rTimeButton ).
    THIS-OBJECT:Controls:Add( rCloseButton ).
    THIS-OBJECT:AcceptButton = rTimeButton.
    
    /* Adjust form size and the location for field and button */
    THIS-OBJECT:Width = rDateField:Width * 2.
    THIS-OBJECT:Height = rCloseButton:Top + rCloseButton:Height 
                         + rDateField:Height + 40.
    rDateField:Left = ( THIS-OBJECT:Width - rDateField:Width ) / 2.
    rTimeButton:Left = ( THIS-OBJECT:Width - ( rTimeButton:Width + 10 
                                               + rCloseButton:Width ) ) / 2.
    rCloseButton:Left = rTimeButton:Left + rTimeButton:Width + 10.

    THIS-OBJECT:ResumeLayout( FALSE ).
  
  END METHOD.
  
  /* Private form event handlers */
  METHOD PRIVATE VOID TimeButton_Click( sender AS System.Object, 
                                        e AS System.EventArgs ):
    dtNow = NOW.
    rDateField:Text = STRING(dtNow).
  END METHOD.
    
  METHOD PRIVATE VOID CloseButton_Click( sender AS System.Object, 
                                         e AS System.EventArgs ):
    Close( ).
  END METHOD.
  
END CLASS.
