&ANALYZE-SUSPEND _VERSION-NUMBER AB_v9r12
&ANALYZE-RESUME
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS Procedure 
/*********************************************************************
* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
* below.  All Rights Reserved.                                       *
*                                                                    *
* The Initial Developer of the Original Code is PSC.  The Original   *
* Code is Progress IDE code released to open source December 1, 2000.*
*                                                                    *
* The contents of this file are subject to the Possenet Public       *
* License Version 1.0 (the "License"); you may not use this file     *
* except in compliance with the License.  A copy of the License is   *
* available as of the date of this notice at                         *
* http://www.possenet.org/license.html                               *
*                                                                    *
* Software distributed under the License is distributed on an "AS IS"*
* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
* should refer to the License for the specific language governing    *
* rights and limitations under the License.                          *
*                                                                    *
* Contributors:                                                      *
*                                                                    *
*********************************************************************/
/*--------------------------------------------------------------------------
    File        : datacustom.p
    Purpose     : Super procedure to extend data class.

    Syntax      : datacustom.p

    Modified    : 06/03/1999
  ------------------------------------------------------------------------*/
/*          This .W file was created with the Progress UIB.             */
/*----------------------------------------------------------------------*/

/* ***************************  Definitions  ************************** */

&SCOPED-DEFINE ADMSuper datacustom.p

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE Procedure
&Scoped-define DB-AWARE no



/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME



/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: Procedure
   Allow: 
   Frames: 0
   Add Fields to: Neither
   Other Settings: CODE-ONLY COMPILE
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
/* DESIGN Window definition (used by the UIB) 
  CREATE WINDOW Procedure ASSIGN
         HEIGHT             = 1.76
         WIDTH              = 44.6.
/* END WINDOW DEFINITION */
                                                                        */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _INCLUDED-LIB Procedure 
/* ************************* Included-Libraries *********************** */

{src/adm2/dataprop.i}

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


 


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK Procedure 


/* ***************************  Main Block  *************************** */

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&IF DEFINED(EXCLUDE-fieldEditValidate) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE fieldEditValidate Procedure 
PROCEDURE fieldEditValidate :
/*------------------------------------------------------------------------------
  Purpose:     Perform validation stored in the entity field edit table.
  Parameters:  OUTPUT pcMessageList AS CHARACTER
  Notes:       Invoked by SDO data logic procedure RowObjectValidate, if any
               errors occurs, they should be passed back to RowObjectValidate.
------------------------------------------------------------------------------*/
DEFINE OUTPUT PARAMETER pcMessageList  AS CHARACTER  NO-UNDO.

DEFINE VARIABLE cEditValue         AS CHARACTER  NO-UNDO.
DEFINE VARIABLE cEnabledTAbles     AS CHARACTER  NO-UNDO.
DEFINE VARIABLE cTable             AS CHARACTER  NO-UNDO.
DEFINE VARIABLE cValueList         AS CHARACTER  NO-UNDO.
DEFINE VARIABLE hColumn            AS HANDLE     NO-UNDO.
DEFINE VARIABLE hFieldEditManager  AS HANDLE     NO-UNDO.
DEFINE VARIABLE hLogicBuffer       AS HANDLE     NO-UNDO.
DEFINE VARIABLE iCol               AS INTEGER    NO-UNDO.
DEFINE VARIABLE iNumTables         AS INTEGER    NO-UNDO.


  hFieldEditManager= DYNAMIC-FUNCTION('getManagerHandle':U IN gshSessionManager,
                                       INPUT 'FieldEditManager':U).

  RUN getLogicBuffer IN TARGET-PROCEDURE (OUTPUT hLogicBuffer).
  DO iCol = 1 TO hLogicBuffer:NUM-FIELDS:
    hColumn = hLogicBuffer:BUFFER-FIELD(iCol).
    cTable = DYNAMIC-FUNCTION('columnTable':U IN TARGET-PROCEDURE,
                              INPUT hColumn:NAME).
    
    IF VALID-HANDLE(hFieldEditManager) THEN 
    DO:
      RUN getFieldEditData IN hFieldEditManager
        (INPUT cTable,
         INPUT hColumn:NAME,
         INPUT 'Required':U,
         OUTPUT cEditValue).

      IF cEditValue = 'yes':U AND hColumn:BUFFER-VALUE = '':U THEN
        ASSIGN pcMessageList = pcMessageList + (IF NUM-ENTRIES(pcMessageList,CHR(3)) > 0 THEN CHR(3) ELSE '':U) +
                    {aferrortxt.i 'AF' '1' cTable hColumn:NAME hColumn:LABEL}.
        
    END.  /* if valid field edit manager handle */
  END.  /* do to number of fields in logic buffer */

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-writeBeginTransFieldEditVal) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE writeBeginTransFieldEditVal Procedure 
PROCEDURE writeBeginTransFieldEditVal :
/*------------------------------------------------------------------------------
  Purpose:     Perform validation stored in the entity field edit table.
  Parameters:  <none>
  Notes:       Invoked by SDO data logic procedure writeBeginTransValidate.
------------------------------------------------------------------------------*/
DEFINE VARIABLE cEditValue         AS CHARACTER  NO-UNDO.
DEFINE VARIABLE cEnabledTAbles     AS CHARACTER  NO-UNDO.
DEFINE VARIABLE cTable             AS CHARACTER  NO-UNDO.
DEFINE VARIABLE cValueList         AS CHARACTER  NO-UNDO.
DEFINE VARIABLE hColumn            AS HANDLE     NO-UNDO.
DEFINE VARIABLE hFieldEditManager  AS HANDLE     NO-UNDO.
DEFINE VARIABLE hLogicBuffer       AS HANDLE     NO-UNDO.
DEFINE VARIABLE iCol               AS INTEGER    NO-UNDO.
DEFINE VARIABLE iNumTables         AS INTEGER    NO-UNDO.

  hFieldEditManager= DYNAMIC-FUNCTION('getManagerHandle':U IN gshSessionManager,
                                       INPUT 'FieldEditManager':U).

  RUN getLogicBuffer IN TARGET-PROCEDURE (OUTPUT hLogicBuffer).
  DO iCol = 1 TO hLogicBuffer:NUM-FIELDS:
    hColumn = hLogicBuffer:BUFFER-FIELD(iCol).
    cTable = DYNAMIC-FUNCTION('columnTable':U IN TARGET-PROCEDURE,
                              INPUT hColumn:NAME).
    
    IF VALID-HANDLE(hFieldEditManager) THEN 
    DO:
      RUN getFieldEditData IN hFieldEditManager
        (INPUT cTable,
         INPUT hColumn:NAME,
         INPUT 'Case':U,
         OUTPUT cEditValue).

      CASE cEditValue:
          WHEN 'Upper':U THEN
            ASSIGN hColumn:BUFFER-VALUE = CAPS(hColumn:BUFFER-VALUE).
          WHEN 'Lower':U THEN
            ASSIGN hColumn:BUFFER-VALUE = LC(hColumn:BUFFER-VALUE).
      END CASE.
        
    END.  /* if valid field edit manager handle */
  END.  /* do to number of fields in logic buffer */

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

