&ANALYZE-SUSPEND _VERSION-NUMBER AB_v9r12
&ANALYZE-RESUME
{adecomm/appserv.i}
DEFINE VARIABLE h_Astra                    AS HANDLE          NO-UNDO.
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _XFTR "Check Version Notes Wizard" Procedure _INLINE
/* Actions: af/cod/aftemwizcw.w ? ? ? ? */
/* MIP Update Version Notes Wizard
Check object version notes.
af/cod/aftemwizpw.w
*/
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _XFTR "Update-Object-Version" Procedure _INLINE
/* Actions: ? ? ? ? af/sup/afverxftrp.p */
/* This has to go above the definitions sections, as that is what it modifies.
   If its not, then the definitions section will have been saved before the
   XFTR code kicks in and changes it */
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _XFTR "Definition Comments Wizard" Procedure _INLINE
/* Actions: ? af/cod/aftemwizcw.w ? ? ? */
/* Program Definition Comment Block Wizard
Welcome to the Program Definition Comment Block Wizard. Press Next to proceed.
af/cod/aftemwizpw.w
*/
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS Procedure 
/*---------------------------------------------------------------------------------
  File: fldedsrvrp.p

  Description:  Field Edit Validation manager

  Purpose:

  Parameters:   <none>

  History:
  --------
  (v:010000)    Task:           0   UserRef:    
                Date:   07/31/2002  Author:     

  Update Notes: Created from Template rytemmngrp.p

---------------------------------------------------------------------------------*/
/*                   This .W file was created with the Progress UIB.             */
/*-------------------------------------------------------------------------------*/

/* ***************************  Definitions  ************************** */
/* MIP-GET-OBJECT-VERSION pre-processors
   The following pre-processors are maintained automatically when the object is
   saved. They pull the object and version from Roundtable if possible so that it
   can be displayed in the about window of the container */

&scop object-name       fldedsrvrp.p
DEFINE VARIABLE lv_this_object_name AS CHARACTER INITIAL "{&object-name}":U NO-UNDO.
&scop object-version    000000

/* Astra object identifying preprocessor */
&glob   AstraPlip    yes

DEFINE VARIABLE cObjectName         AS CHARACTER NO-UNDO.

ASSIGN cObjectName = "{&object-name}":U.

&scop   mip-notify-user-on-plip-close   NO

{src/adm2/globals.i}

DEFINE TEMP-TABLE ttFieldEditData NO-UNDO
    FIELD cEntityName          AS CHARACTER
    FIELD cFieldName           AS CHARACTER
    FIELD cEditType            AS CHARACTER
    FIELD cEditValue           AS CHARACTER
    INDEX key1 AS UNIQUE PRIMARY cEntityName cFieldName cEditType.

DEFINE TEMP-TABLE ttNewData NO-UNDO LIKE ttFieldEditData.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE Procedure
&Scoped-define DB-AWARE yes


/* Db-Required definitions. */
&IF DEFINED(DB-REQUIRED) = 0 &THEN
    &GLOBAL-DEFINE DB-REQUIRED TRUE
&ENDIF
&GLOBAL-DEFINE DB-REQUIRED-START   &IF {&DB-REQUIRED} &THEN
&GLOBAL-DEFINE DB-REQUIRED-END     &ENDIF



/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME



/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: Procedure
   Allow: 
   Frames: 0
   Add Fields to: Neither
   Other Settings: CODE-ONLY APPSERVER DB-AWARE
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
/* DESIGN Window definition (used by the UIB) 
  CREATE WINDOW Procedure ASSIGN
         HEIGHT             = 1.52
         WIDTH              = 43.8.
/* END WINDOW DEFINITION */
                                                                        */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _INCLUDED-LIB Procedure 
/* ************************* Included-Libraries *********************** */

{src/adm/method/attribut.i}

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


 


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK Procedure 


/* ***************************  Main Block  ******************************* */

{ry/app/ryplipmain.i}

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&IF DEFINED(EXCLUDE-cacheFieldEdits) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE cacheFieldEdits Procedure 
PROCEDURE cacheFieldEdits :
/*------------------------------------------------------------------------------
  Purpose:     This procedure caches field edit data for a list of tables.
  Parameters:  INPUT pcTableList AS CHARACTER
  Notes:       This checks for the existence of any field edit data for a
               table.  If field edit data does not exist for the table, it is
               read from the database.
------------------------------------------------------------------------------*/
DEFINE INPUT  PARAMETER pcTableList AS CHARACTER  NO-UNDO.

  DEFINE VARIABLE iNum             AS INTEGER    NO-UNDO.
  DEFINE VARIABLE cTablesToRead    AS CHARACTER  NO-UNDO.
  
  DO iNum = 1 TO NUM-ENTRIES(pcTableList):
    FIND FIRST ttFieldEditData WHERE 
        ttFieldEditData.cEntityName = ENTRY(iNum, pcTableList) NO-ERROR.
    IF NOT AVAILABLE ttFieldEditData THEN
      cTablesToRead = cTablesToRead + 
        (IF NUM-ENTRIES(cTablesToRead) > 0 THEN ',':U ELSE '':U) +
          ENTRY(iNum,pcTableList).
  END.  /* do iNum to number entries in table list */

  IF cTablesToRead NE '':U THEN DO:
    IF LOOKUP('fetchFieldEdits', THIS-PROCEDURE:INTERNAL-ENTRIES) NE 0 THEN
        RUN fetchFieldEdits (INPUT pcTableList, 
                             OUTPUT TABLE ttNewData).
/*     ELSE {dynlaunch.i                                                        */
/*             &PLIP       = 'FieldEditManager'                                 */
/*             &iProc      = 'fetchFieldEdits'                                  */
/*             &mode1      = INPUT &parm1 =  pcTableList &dataType1 = CHARACTER */
/*             &mode2      = OUTPUT &parm2 = ttNewData &dataType2 = TABLE       */
/*          }                                                                   */

        FOR EACH ttNewData:
            CREATE ttFieldEditData.
            BUFFER-COPY ttNewData TO ttFieldEditData.
        END.

  END.    /* END DO IF cTablesToRead */
  
  RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-clearClientCache) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE clearClientCache Procedure 
PROCEDURE clearClientCache :
/*------------------------------------------------------------------------------
  Purpose:     This procedure clears the cache of field edit data.
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  
  IF NOT (SESSION:REMOTE OR SESSION:CLIENT-TYPE = "WEBSPEED":U) THEN
  DO:
    EMPTY TEMP-TABLE ttFieldEditData.
  END.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

{&DB-REQUIRED-START}

&IF DEFINED(EXCLUDE-fetchFieldEdits) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE fetchFieldEdits Procedure  _DB-REQUIRED
PROCEDURE fetchFieldEdits :
/*------------------------------------------------------------------------------
  Purpose:     Server-side procedure to load field edit data from the database
               into a temp-table, to be returned to the client.
  Parameters:  INPUT  PARAMETER pcTableList AS CHARACTER  NO-UNDO -- 
                         list of tables to cache.
               OUTPUT PARAMETER TABLE FOR ttNewData -- 
                         returned temp-table.
  Notes:       This DB-REQUIRED procedure is executed on the server, from the 
               client, if the Manager is divided between client and server. 
               It only loads newly requested data into the NewData temp-table, 
               and returns that to be appended to the client cache.
------------------------------------------------------------------------------*/
DEFINE INPUT  PARAMETER pcTableList AS CHARACTER  NO-UNDO.
DEFINE OUTPUT PARAMETER TABLE FOR ttNewData.
  
DEFINE VARIABLE iNum AS INTEGER    NO-UNDO.

    /* Remove any leftover data from a previous request. The ttNewData table
       just holds the data for the current request and returns that to the client. */  
    EMPTY TEMP-TABLE ttNewData.

    /* Read field edit data from database into the temp-table to return
       to the caller. */
      DO iNum = 1 TO NUM-ENTRIES(pcTableList):
        FIND FIRST gsc_entity_mnemonic WHERE 
            gsc_entity_mnemonic.entity_mnemonic_description = 
              ENTRY(iNum, pcTableList) NO-LOCK NO-ERROR.
        IF AVAILABLE gsc_entity_mnemonic THEN DO:
          FOR EACH gsc_entity_display_field OF gsc_entity_mnemonic,
              EACH gsc_entity_field_edit OF gsc_entity_display_field NO-LOCK:
            
              CREATE ttNewData.
              ASSIGN 
                ttNewData.cEntityName = gsc_entity_mnemonic.entity_mnemonic_description
                ttNewData.cFieldName  = gsc_entity_display_field.DISPLAY_field_name
                ttNewData.cEditType   = gsc_entity_field_edit.edit_type
                ttNewData.cEditValue  = gsc_entity_field_edit.edit_value.
          END.  /* for each entity field edit of each display field */
        END.  /* if available entity */
      END.  /* do to number of tables */

      RETURN.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

{&DB-REQUIRED-END}

&IF DEFINED(EXCLUDE-getFieldEditData) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE getFieldEditData Procedure 
PROCEDURE getFieldEditData :
/*------------------------------------------------------------------------------
  Purpose:     Returns field edit data for a database field.  It can return
               edit values for one or more edit types.
  Parameters:  INPUT  pcTable      AS CHARACTER - Table name
               INPUT  pcField      AS CHARACTER - Field name
               INPUT  pcEditTypes  AS CHARACTER - Edit Types
                                               can be a comma-delimited list
               OUTPUT pcEditValues AS CHARACTER - Edit Values
                                               will be a CHR(3)-delimited list 
                                               for multiple edit types
  Notes:       
------------------------------------------------------------------------------*/
DEFINE INPUT  PARAMETER pcTable      AS CHARACTER  NO-UNDO.
DEFINE INPUT  PARAMETER pcField      AS CHARACTER  NO-UNDO.
DEFINE INPUT  PARAMETER pcEditTypes  AS CHARACTER  NO-UNDO.
DEFINE OUTPUT PARAMETER pcEditValues AS CHARACTER  NO-UNDO.

DEFINE VARIABLE iTypes AS INTEGER    NO-UNDO.
  DO iTypes = 1 TO NUM-ENTRIES(pcEditTypes):
    FIND ttFieldEditData WHERE 
        ttFieldEditData.cEntityName = pcTable AND
        ttFieldEditData.cFieldName  = pcField AND
        ttFieldEditData.cEditType   = ENTRY(iTypes, pcEditTypes) NO-LOCK NO-ERROR.
    pcEditValues = pcEditValues + 
        (IF iTypes > 1 THEN CHR(3) ELSE '':U) +
          IF AVAILABLE ttFieldEditData THEN
            ttFieldEditData.cEditValue ELSE '':U.
  END.  /* DO 1 to number of edit type entries */

  RETURN.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-killPlip) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE killPlip Procedure 
PROCEDURE killPlip :
/*------------------------------------------------------------------------------
  Purpose:     entry point to instantly kill the plip if it should get lost in memory
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/

{ry/app/ryplipkill.i}

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-objectDescription) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE objectDescription Procedure 
PROCEDURE objectDescription :
/*------------------------------------------------------------------------------
  Purpose:     Pass out a description of the PLIP, used in Plip temp-table
  Parameters:  <none>
  Notes:       This should be changed manually for each plip
------------------------------------------------------------------------------*/

DEFINE OUTPUT PARAMETER cDescription AS CHARACTER NO-UNDO.

ASSIGN cDescription = "Dynamics Template PLIP".

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-plipSetup) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE plipSetup Procedure 
PROCEDURE plipSetup :
/*------------------------------------------------------------------------------
  Purpose:    Run by main-block of PLIP at startup of PLIP
  Parameters: <none>
  Notes:       
------------------------------------------------------------------------------*/

{ry/app/ryplipsetu.i}
MESSAGE "fieldedit manager".
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-plipShutdown) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE plipShutdown Procedure 
PROCEDURE plipShutdown :
/*------------------------------------------------------------------------------
  Purpose:     This procedure will be run just before the calling program 
               terminates
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/

{ry/app/ryplipshut.i}

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

