&ANALYZE-SUSPEND _VERSION-NUMBER AB_v9r12
&ANALYZE-RESUME
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS Procedure 
/*********************************************************************
* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
* below.  All Rights Reserved.                                       *
*                                                                    *
* The Initial Developer of the Original Code is PSC.  The Original   *
* Code is Progress IDE code released to open source December 1, 2000.*
*                                                                    *
* The contents of this file are subject to the Possenet Public       *
* License Version 1.0 (the "License"); you may not use this file     *
* except in compliance with the License.  A copy of the License is   *
* available as of the date of this notice at                         *
* http://www.possenet.org/license.html                               *
*                                                                    *
* Software distributed under the License is distributed on an "AS IS"*
* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
* should refer to the License for the specific language governing    *
* rights and limitations under the License.                          *
*                                                                    *
* Contributors:                                                      *
*                                                                    *
*********************************************************************/
/*--------------------------------------------------------------------------
    File        : viewercustom.p
    Purpose     : Super procedure to extend viewer class.

    Syntax      : viewercustom.p

    Modified    : 06/03/1999
  ------------------------------------------------------------------------*/
/*          This .W file was created with the Progress UIB.             */
/*----------------------------------------------------------------------*/

/* ***************************  Definitions  ************************** */

&SCOPED-DEFINE ADMSuper viewercustom.p

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE Procedure
&Scoped-define DB-AWARE no



/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME



/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: Procedure
   Allow: 
   Frames: 0
   Add Fields to: Neither
   Other Settings: CODE-ONLY COMPILE
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
/* DESIGN Window definition (used by the UIB) 
  CREATE WINDOW Procedure ASSIGN
         HEIGHT             = 15
         WIDTH              = 60.
/* END WINDOW DEFINITION */
                                                                        */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _INCLUDED-LIB Procedure 
/* ************************* Included-Libraries *********************** */

{src/adm2/viewprop.i}

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


 


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK Procedure 


/* ***************************  Main Block  *************************** */

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&IF DEFINED(EXCLUDE-enableFields) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enableFields Procedure 
PROCEDURE enableFields :
/*------------------------------------------------------------------------------
  Purpose:     Override of enableFields to apply affordance for field edits 
               defined in the entity field edit table.
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
DEFINE VARIABLE cEditValue        AS CHARACTER  NO-UNDO.
DEFINE VARIABLE cFieldHandles     AS CHARACTER  NO-UNDO.
DEFINE VARIABLE cTable            AS CHARACTER  NO-UNDO.
DEFINE VARIABLE hDataSource       AS HANDLE     NO-UNDO.
DEFINE VARIABLE hField            AS HANDLE     NO-UNDO.
DEFINE VARIABLE hFieldEditManager AS HANDLE     NO-UNDO.
DEFINE VARIABLE hSideLabel        AS HANDLE     NO-UNDO.
DEFINE VARIABLE iNumField         AS INTEGER    NO-UNDO.

  RUN SUPER.

  hFieldEditManager= DYNAMIC-FUNCTION('getManagerHandle':U IN gshSessionManager,
                                       INPUT 'FieldEditManager':U).

  hDataSource = DYNAMIC-FUNCTION('getDataSource':U IN TARGET-PROCEDURE).

  cFieldHandles = DYNAMIC-FUNCTION('getFieldHandles':U IN TARGET-PROCEDURE).

  DO iNumField = 1 TO NUM-ENTRIES(cFieldHandles):
    hField = WIDGET-HANDLE(ENTRY(iNumField, cFieldHandles)).

    cTable = DYNAMIC-FUNCTION('columnTable':U IN hDataSource,
                              INPUT hField:NAME).

    IF VALID-HANDLE(hFieldEditManager) THEN
    DO:
      RUN getFieldEditData IN hFieldEditManager
          (INPUT cTable,
           INPUT hField:NAME,
           INPUT 'Required':U,
           OUTPUT cEditValue).
      
      IF cEditValue = 'yes':U THEN 
      DO:
        ASSIGN
          hSideLabel = hField:SIDE-LABEL-HANDLE
          hSideLabel:SCREEN-VALUE = '* ':U + hSideLabel:SCREEN-VALUE NO-ERROR.
      END.  /* if required is "yes" */
    END.  /* if field edit manager valid */
  END.  /* do to number of data fields in viewer */

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

