&ANALYZE-SUSPEND _VERSION-NUMBER AB_v9r12
&ANALYZE-RESUME
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS Procedure 
/*********************************************************************
* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
* below.  All Rights Reserved.                                       *
*                                                                    *
* The Initial Developer of the Original Code is PSC.  The Original   *
* Code is Progress IDE code released to open source December 1, 2000.*
*                                                                    *
* The contents of this file are subject to the Possenet Public       *
* License Version 1.0 (the "License"); you may not use this file     *
* except in compliance with the License.  A copy of the License is   *
* available as of the date of this notice at                         *
* http://www.possenet.org/license.html                               *
*                                                                    *
* Software distributed under the License is distributed on an "AS IS"*
* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
* should refer to the License for the specific language governing    *
* rights and limitations under the License.                          *
*                                                                    *
* Contributors:                                                      *
*                                                                    *
*********************************************************************/
/*--------------------------------------------------------------------------
    File        : browsercustom.p
    Purpose     : Super procedure to extend browser class.

    Syntax      : browsercustom.p

    Modified    : Frank Beusenberg (fbe@progress.com)
                  
  ------------------------------------------------------------------------*/
/*          This .W file was created with the Progress UIB.             */
/*----------------------------------------------------------------------*/

/* ***************************  Definitions  ************************** */

&SCOPED-DEFINE ADMSuper browsercustom.p

{af/app/aftttranslate.i}

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE Procedure
&Scoped-define DB-AWARE no



/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME


/* ************************  Function Prototypes ********************** */

&IF DEFINED(EXCLUDE-getBrowseColumnsMovable) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD getBrowseColumnsMovable Procedure 
FUNCTION getBrowseColumnsMovable RETURNS LOGICAL
  ( /* parameter-definitions */ )  FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-getBrowsePopupActive) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD getBrowsePopupActive Procedure 
FUNCTION getBrowsePopupActive RETURNS LOGICAL
  ( )  FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-setBrowseColumnsMovable) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD setBrowseColumnsMovable Procedure 
FUNCTION setBrowseColumnsMovable RETURNS LOGICAL
  ( INPUT plValue AS LOGICAL ) FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-setBrowsePopupActive) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD setBrowsePopupActive Procedure 
FUNCTION setBrowsePopupActive RETURNS LOGICAL
  ( INPUT plActive AS LOGICAL ) FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: Procedure
   Compile into: adm2/custom
   Allow: 
   Frames: 0
   Add Fields to: Neither
   Other Settings: CODE-ONLY COMPILE
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
/* DESIGN Window definition (used by the UIB) 
  CREATE WINDOW Procedure ASSIGN
         HEIGHT             = 3.33
         WIDTH              = 49.2.
/* END WINDOW DEFINITION */
                                                                        */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _INCLUDED-LIB Procedure 
/* ************************* Included-Libraries *********************** */

{src/adm2/brsprop.i}

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


 


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK Procedure 


/* ***************************  Main Block  *************************** */

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&IF DEFINED(EXCLUDE-createBrowsePopupMenu) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE createBrowsePopupMenu Procedure 
PROCEDURE createBrowsePopupMenu PRIVATE :
/*------------------------------------------------------------------------------
  Purpose:     This procedure creates the dynamic popup menu with the Browser options.
  Parameters:  INPUT hTarget AS HANDLE -- Dynamic Browser procedure handle.
  Notes:       
------------------------------------------------------------------------------*/

    DEFINE INPUT  PARAMETER hTarget     AS HANDLE     NO-UNDO.

    DEFINE VARIABLE hBrowse             AS HANDLE     NO-UNDO.
    DEFINE VARIABLE hPopupMenu          AS HANDLE     NO-UNDO.
    DEFINE VARIABLE hColsMovableItem    AS HANDLE     NO-UNDO.
    DEFINE VARIABLE hColsSortableItem   AS HANDLE     NO-UNDO.
    DEFINE VARIABLE hSaveItem           AS HANDLE     NO-UNDO.
    DEFINE VARIABLE hRuleItem           AS HANDLE     NO-UNDO.
    DEFINE VARIABLE hResetItem          AS HANDLE     NO-UNDO.
    DEFINE VARIABLE hExitItem           AS HANDLE     NO-UNDO.
    DEFINE VARIABLE lValue              AS LOGICAL    NO-UNDO.
    DEFINE VARIABLE cStrings            AS CHARACTER  NO-UNDO
        INIT "Move Columns,Sort Columns,Save Browser Settings,Reset Browser Settings,Exit".
    DEFINE VARIABLE iString             AS INTEGER    NO-UNDO.
    
    hBrowse = DYNAMIC-FUNCTION( "getBrowseHandle":U IN hTarget ).
    IF NOT VALID-HANDLE( hBrowse ) THEN RETURN.

    /*  Create the POPUP MENU for the Browser. The labels of the individual */
    /*  menu items could also be translatable by using the translatePhrase  */
    /*  API call.                                                           */

    
    CREATE MENU hPopupMenu
        ASSIGN  POPUP-ONLY  = TRUE.

/* cString = DYNAMIC-FUNCTION ('translatePhrase' IN gshTranslationManager, */
/*                                INPUT "Move Columns",                    */
/*                                INPUT 0).                                */

    DO iString = 1 TO NUM-ENTRIES(cStrings):
        CREATE ttTranslate.
        ASSIGN ttTranslate.dLanguageObj = 0   /* Use the login language */
               ttTranslate.cObjectName = ""
               ttTranslate.lGlobal = NO
               ttTranslate.cWidgetType = "TEXT"
               ttTranslate.cWidgetName = ENTRY(iString, cStrings).
    END.

    RUN multiTranslation IN gshTranslationManager
        (INPUT NO,    /* Not for all languages */
         INPUT-OUTPUT TABLE ttTranslate).

    /* If the current language is the original language or one for which
       there are no translations, then cTranslatedLabel is not set, so
       fall back on the original text. */
    FOR EACH ttTranslate:
        IF ttTranslate.cTranslatedLabel = "" THEN
           ttTranslate.cTranslatedLabel = cWidgetName.
    END.

    FIND ttTranslate WHERE ttTranslate.cWidgetName = "Move Columns".
    CREATE MENU-ITEM hColsMovableItem
        ASSIGN  PARENT      = hPopupMenu
                LABEL       = ttTranslate.cTranslatedLabel /* "&Move Columns" */
                NAME        = "ColsMovable"
                TOGGLE-BOX  = TRUE
                CHECKED     = FALSE.

    FIND ttTranslate WHERE ttTranslate.cWidgetName = "Sort Columns".
    CREATE MENU-ITEM hColsSortableItem
        ASSIGN  PARENT      = hPopupMenu
                LABEL       = ttTranslate.cTranslatedLabel /* "&Sort Columns" */
                NAME        = "ColsSortable"
                TOGGLE-BOX  = TRUE
                CHECKED     = TRUE.

    CREATE MENU-ITEM hRuleItem
        ASSIGN  PARENT      = hPopupMenu
                SUBTYPE     = "RULE".

    FIND ttTranslate WHERE ttTranslate.cWidgetName = "Save Browser Settings".
    CREATE MENU-ITEM hSaveItem
        ASSIGN  PARENT      = hPopupMenu
                LABEL       = ttTranslate.cTranslatedLabel /* "Save &Browser Settings" */
                NAME        = "SaveBrowseSettings".

    FIND ttTranslate WHERE ttTranslate.cWidgetName = "Reset Browser Settings".
    CREATE MENU-ITEM hResetItem
        ASSIGN  PARENT      = hPopupMenu
                LABEL       = ttTranslate.cTranslatedLabel /* "&Reset Browser Settings" */
                NAME        = "ResetBrowseSettings".

    CREATE MENU-ITEM hRuleItem
        ASSIGN  PARENT      = hPopupMenu
                SUBTYPE     = "RULE".

    FIND ttTranslate WHERE ttTranslate.cWidgetName = "Exit".
    CREATE MENU-ITEM hExitItem
        ASSIGN  PARENT      = hPopupMenu
                LABEL       = ttTranslate.cTranslatedLabel. /* "E&xit" */

    EMPTY TEMP-TABLE ttTranslate.
    /* Add POPUP Menu to the Browse Widget. */

    hBrowse:POPUP-MENU = hPopupMenu.

    /* Popup Menu Trigger code. */

    ON MENU-DROP OF hPopupMenu
        PERSISTENT RUN eventPopupMenuMenuDrop IN hTarget ( INPUT hPopupMenu ).
    ON VALUE-CHANGED OF hColsMovableItem
        PERSISTENT RUN eventMenuItemValueChanged IN hTarget ( INPUT hColsMovableItem ).
    ON VALUE-CHANGED OF hColsSortableItem
        PERSISTENT RUN eventMenuItemValueChanged IN hTarget ( INPUT hColsSortableItem ).
    ON CHOOSE OF hSaveItem
        PERSISTENT RUN eventMenuItemChoose IN hTarget ( INPUT hSaveItem ).
    ON CHOOSE OF hResetItem
        PERSISTENT RUN eventMenuItemChoose IN hTarget ( INPUT hResetItem ).

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-eventMenuItemChoose) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE eventMenuItemChoose Procedure 
PROCEDURE eventMenuItemChoose :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/

    DEFINE INPUT  PARAMETER hMenuItem   AS HANDLE     NO-UNDO.

    DEFINE VARIABLE cProfileKey         AS CHARACTER  NO-UNDO.
    DEFINE VARIABLE hBrowser            AS HANDLE     NO-UNDO.
    DEFINE VARIABLE hColumn             AS HANDLE     NO-UNDO.
    DEFINE VARIABLE cColumnData         AS CHARACTER  NO-UNDO.
    DEFINE VARIABLE hContainerSource    AS HANDLE     NO-UNDO.
    DEFINE VARIABLE cContainerName      AS CHARACTER  NO-UNDO.
    DEFINE VARIABLE cBrowserName        AS CHARACTER  NO-UNDO.
    DEFINE VARIABLE rRowID              AS ROWID      NO-UNDO.
    DEFINE VARIABLE hDataSource         AS HANDLE     NO-UNDO.
    DEFINE VARIABLE cQuerySort          AS CHARACTER  NO-UNDO.
    DEFINE VARIABLE lDeleteProfileEntry AS LOGICAL    NO-UNDO.
    DEFINE VARIABLE cMessage            AS CHARACTER  NO-UNDO.
    DEFINE VARIABLE cAnswer             AS CHARACTER  NO-UNDO.
    DEFINE VARIABLE cButtonPressed      AS CHARACTER  NO-UNDO.

    {get BrowseHandle hBrowser}.
    {get ObjectName cBrowserName}.
    {get ContainerSource hContainerSource}.
    {get DataSource hDataSource}.
    {get QuerySort cQuerySort hDataSource}.

    IF NOT VALID-HANDLE( hBrowser ) THEN RETURN.

    /* Is this a Save action or a Reset action? */

    IF ( hMenuItem:NAME = "SaveBrowseSettings" ) THEN
    DO:
        ASSIGN cMessage = {aferrortxt.i 'BR' '1'} /* "Save browser settings?" */
               lDeleteProfileEntry = FALSE.
    END.
    ELSE IF ( hMenuItem:NAME = "ResetBrowseSettings" ) THEN
    DO:
        ASSIGN cMessage = {aferrortxt.i 'BR' '2'} /* "Reset browser settings?" */
               lDeleteProfileEntry = TRUE.
    END.
    ELSE
        RETURN.

    /* Ask user for save or reset confirmation. */
    RUN askQuestion IN gshSessionManager (
         INPUT cMessage,
         INPUT "OK,Cancel",
         INPUT "OK",
         INPUT "Cancel",
         INPUT "",
         INPUT "",
         INPUT "",
         INPUT-OUTPUT cAnswer,
         OUTPUT cButtonPressed).

    /* Only continue this if user pressed the "OK" button. */
    IF ( cButtonPressed <> "OK" ) THEN
        RETURN.

    /* Get the container name. */
    IF VALID-HANDLE( hContainerSource ) THEN
        {get LogicalObjectName cContainerName hContainerSource} NO-ERROR.
    ELSE
        cContainerName = "".
    
    IF ( cContainerName = "" ) AND VALID-HANDLE( hContainerSource ) THEN
        cContainerName = hContainerSource:FILE-NAME.


    /*
    **  Save Browser Column settings into user profile.
    **
    **  Profile type is set to: Browser
    **  Profile code is set to: Column
    **  Profile key is set to: <containerName><browserName>
    **  Profile data is set to: ColumnData
    **
    **  The input parameter "PER" is used to store the profile information
    **  permanently. This should be taken from the session preferences for
    **  this particular user.
    **
    **  The ColumnOrder is just a list of the current column widget name and
    **  the width of the column separated by CHR(3) and CHR(4) chars. The profile
    **  key name will be set to the container name and the browser name to identify
    **  the browser instance for later retrieval and restoration of the same
    **  column order and column widths. The width of the columns is stored in
    **  pixels.
    **
    **  Example:
    **
    **      "CustNum"CHR(4)"100"CHR(3)"PostalCode"CHR(4)"60"CHR(3) etc...
    **      without the quotes ;-)
    */
    
    cProfileKey = cContainerName + cBrowserName.

    IF NOT lDeleteProfileEntry THEN
    DO:
        /* Get the browser column order and column widths. */
        ASSIGN
            cColumnData = ""
            hColumn     = hBrowser:FIRST-COLUMN.

        DO WHILE VALID-HANDLE( hColumn ):
            cColumnData = cColumnData + IF ( cColumnData = "" ) THEN "" ELSE CHR(3).
            cColumnData = cColumnData + hColumn:NAME + CHR(4) + STRING( hColumn:WIDTH-PIXELS ).
            hColumn     = hColumn:NEXT-COLUMN.
        END.
    END.
    
    /* Save column settings to user profile. */
    ASSIGN rRowID = ?.

    RUN setProfileData IN gshProfileManager (
        INPUT "Browser",
        INPUT "Columns",
        INPUT cProfileKey,
        INPUT rRowID,
        INPUT cColumnData,
        INPUT lDeleteProfileEntry,
        INPUT "PER" ).
    
    /* Get browser sort settings. */
    IF NOT lDeleteProfileEntry THEN
    DO:
        IF NOT VALID-HANDLE( hDataSource ) THEN RETURN.
        {get QuerySort cQuerySort hDataSource}.
    END.
    
    /* Save the query sort to user profile. */
    ASSIGN rRowID = ?.

    RUN setProfileData IN gshProfileManager (
        INPUT "Browser",
        INPUT "Sorting",
        INPUT cProfileKey,
        INPUT rRowID,
        INPUT cQuerySort,
        INPUT lDeleteProfileEntry,
        INPUT "PER" ).

    /* Show message to user indicating action has been taken. */
    IF NOT lDeleteProfileEntry THEN
                          /* "Saving browser settings succeeded!" */
        ASSIGN cMessage = {aferrortxt.i 'BR' '3'}.
    ELSE
                          /* "Resetting browser settings succeeded!" */
        ASSIGN cMessage = {aferrortxt.i 'BR' '4'}.

    RUN showMessages IN gshSessionManager (
        INPUT cMessage,
        INPUT "INF",
        INPUT "OK",
        INPUT "OK",
        INPUT "",
        INPUT "Browser Settings",
        INPUT NO,
        INPUT ?,
        OUTPUT cButtonPressed ).

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-eventMenuItemValueChanged) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE eventMenuItemValueChanged Procedure 
PROCEDURE eventMenuItemValueChanged :
/*------------------------------------------------------------------------------
  Purpose:     VALUE-CHANGED trigger code for a browser POPUP MENU MenuItem.
  Parameters:  hMenuItem    - Handle to the MenuItem for this trigger.
  Notes:       
------------------------------------------------------------------------------*/

    DEFINE INPUT  PARAMETER hMenuItem   AS HANDLE     NO-UNDO.

    DEFINE VARIABLE lValue      AS LOGICAL    NO-UNDO.
    DEFINE VARIABLE hBrowse     AS HANDLE     NO-UNDO.

    /* Set the appropriate browser properties. */
    {get BrowseHandle hBrowse}.
    IF NOT VALID-HANDLE( hBrowse ) THEN RETURN.

    /* Set COLUMN-MOVABLE off if the Menu Item was "sortable" */
    lValue  = hMenuItem:CHECKED.
    IF ( hMenuItem:NAME = "ColsSortable" ) THEN
        lValue = NOT lValue.
    {set BrowseColumnsMovable lValue}.
    hBrowse:COLUMN-MOVABLE = lValue.
    
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-eventPopupMenuMenuDrop) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE eventPopupMenuMenuDrop Procedure 
PROCEDURE eventPopupMenuMenuDrop :
/*------------------------------------------------------------------------------
  Purpose:     Procedure called when the popup menu is brought up. It checks the
               appropriate menu item -- columns movable or sortable.
  Parameters:  INPUT hMenu AS HANDLE -- handle of the Browser's menu.
  Notes:       
------------------------------------------------------------------------------*/

    DEFINE INPUT  PARAMETER hMenu   AS HANDLE     NO-UNDO.

    DEFINE VARIABLE hMenuItem   AS HANDLE     NO-UNDO.
    DEFINE VARIABLE lMovable    AS LOGICAL    NO-UNDO.
    DEFINE VARIABLE lSaveSort   AS LOGICAL    NO-UNDO.
    DEFINE VARIABLE lSaveMove   AS LOGICAL    NO-UNDO.

    /*  Get current settings based on the Browser Properties    */

    {get BrowseColumnsMovable lMovable}.

    /*  Now, manipulate the POPUP MENU's Items to reflect the property      */
    /*  settings. This is here in case the property values were changed     */
    /*  from the 'outside' using the set() functions.                       */

    hMenuItem = hMenu:FIRST-CHILD.

    DO WHILE VALID-HANDLE( hMenuItem ):

        /* The MenuItems 'Cols Sortable' and 'Cols Movable' are mutually
        ** exclusive, i.e. they behave like a radio set, so we should
        ** flip each one depending on the value of BrowseColumnsMovable. */
        
        IF ( hMenuItem:NAME = "ColsMovable" ) THEN
            hMenuItem:CHECKED = lMovable.
        ELSE IF ( hMenuItem:NAME = "ColsSortable" ) THEN
            hMenuItem:CHECKED = NOT lMovable.

        hMenuItem = hMenuItem:NEXT-SIBLING.

    END.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-initializeObject) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE initializeObject Procedure 
PROCEDURE initializeObject :
/*------------------------------------------------------------------------------
  Purpose:     Override of standard initializeObject behavior to retrieve
               Browser profile settings from the Profile Manager and modify the UI.
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/

    DEFINE VARIABLE hBrowse             AS HANDLE     NO-UNDO.
    DEFINE VARIABLE lPopupActive        AS LOGICAL    NO-UNDO.
    DEFINE VARIABLE hContainerSource    AS HANDLE     NO-UNDO.
    DEFINE VARIABLE cContainerName      AS CHARACTER  NO-UNDO.
    DEFINE VARIABLE cBrowserName        AS CHARACTER  NO-UNDO.
    DEFINE VARIABLE cProfileKey         AS CHARACTER  NO-UNDO.
    DEFINE VARIABLE lProfileExists      AS LOGICAL    NO-UNDO.
    DEFINE VARIABLE cProfileData        AS CHARACTER  NO-UNDO.
    DEFINE VARIABLE rRowID              AS ROWID      NO-UNDO.
    DEFINE VARIABLE iNumEntries         AS INTEGER    NO-UNDO.
    DEFINE VARIABLE iLoop               AS INTEGER    NO-UNDO.
    DEFINE VARIABLE cColumnName         AS CHARACTER  NO-UNDO.
    DEFINE VARIABLE iColumnWidth        AS INTEGER    NO-UNDO.
    DEFINE VARIABLE cColumnEntry        AS CHARACTER  NO-UNDO.
    DEFINE VARIABLE iColumnPosition     AS INTEGER    NO-UNDO.
    DEFINE VARIABLE hColumn             AS HANDLE     NO-UNDO.
    DEFINE VARIABLE hDataSource         AS HANDLE     NO-UNDO.
    DEFINE VARIABLE cDataSourceNames    AS CHARACTER  NO-UNDO.
    DEFINE VARIABLE cSecurityObjects    AS CHARACTER  NO-UNDO.


    /* Run default behavior first. */

    RUN SUPER.

    /*
    **  Put the POPUP Menu on the browser for browser functionality. This
    **  POPUP Menu will have options for the user to choose from like:
    **
    **  Only swith this on when the property BrowsePopupActive is set to YES.
    */

    {get BrowseHandle hBrowse}.
    {get ObjectName cBrowserName}.
    {get DataSource hDataSource}.
    {get DataSourceNames cDataSourceNames}.

    /* Get the name of the container we're in, which is needed by both
       the tokenSecurityCheck and the profile data key. */
    {get ContainerSource hContainerSource}.
    IF VALID-HANDLE( hContainerSource ) THEN
        {get LogicalObjectName cContainerName hContainerSource} NO-ERROR.
    ELSE
        cContainerName = "".

    /* Example of using the Security Manager. If the token BrowsePopup
       comes back for this user, then skip all the profile code. */
    RUN tokenSecurityCheck IN gshSecurityManager
        (INPUT cContainerName, /* pcObjectName */
         INPUT "",             /* pcAttributeCode */
         OUTPUT cSecurityObjects).
    IF LOOKUP("BrowsePopup", cSecurityObjects) NE 0 THEN
        RETURN.

    {get BrowsePopupActive lPopupActive}.
    IF lPopupActive THEN
        RUN createBrowsePopupMenu ( INPUT TARGET-PROCEDURE ).

    /*
    **  Check for profile data for this particular browser and container
    **  combination. If profile data exists, we will read it and modify the
    **  browser accordingly.
    */

    /* Create the ProfileKey. */
    
    IF ( cContainerName = "" ) AND VALID-HANDLE( hContainerSource ) THEN
        cContainerName = hContainerSource:FILE-NAME.

    cProfileKey = cContainerName + cBrowserName.

    /* Try to restore column settings. Check the Profile Manager if the profile
       data we're looking for actually exists... */

    RUN checkProfileDataExists IN gshProfileManager (
        INPUT "Browser",
        INPUT "Columns",
        INPUT cProfileKey,
        INPUT NO,
        INPUT NO,
        OUTPUT lProfileExists ).

    IF lProfileExists THEN
    DO:
        ASSIGN rRowID = ?.

        RUN getProfileData IN gshProfileManager (
            INPUT "Browser",
            INPUT "Columns",
            INPUT cProfileKey,
            INPUT NO,
            INPUT-OUTPUT rRowID,
            OUTPUT cProfileData ).

        /*
        **  Now, if we got valid column data back we will have to 'flip' the existing
        **  columns to the position we have saved them in. Also set the column width
        **  while we're at it.
        **  We will loop through the list of saved column data and try to find the
        **  matching column in the browser. If we found it, we will flip it to the
        **  position specified in the saved data (which is the iLoop variable).
        */

        IF ( cProfileData <> "" ) THEN
        DO:
            iNumEntries = NUM-ENTRIES( cProfileData, CHR(3) ).

            DO iLoop = 1 TO iNumEntries:
                ASSIGN
                    cColumnEntry    = ENTRY( iLoop, cProfileData, CHR(3) )
                    hColumn         = hBrowse:FIRST-COLUMN.
                    iColumnPosition = 1
                    .
                DO WHILE VALID-HANDLE( hColumn ):
                    IF ( hColumn:NAME = ENTRY( 1, cColumnEntry, CHR(4) )) THEN
                    DO:
                        hBrowse:MOVE-COLUMN( iColumnPosition, iLoop ).
                        hColumn:WIDTH-PIXELS = INTEGER( ENTRY( 2, cColumnEntry, CHR(4) )).
                        LEAVE.
                    END.
                    hColumn = hColumn:NEXT-COLUMN.
                    iColumnPosition = iColumnPosition + 1.
                END.
            END.
        END.
    END.

    /* Try to restore browser sort settings. Check the Profile Manager if the profile
       data we're looking for actually exists... */

    RUN checkProfileDataExists IN gshProfileManager (
        INPUT "Browser",
        INPUT "Sorting",
        INPUT cProfileKey,
        INPUT NO,
        INPUT NO,
        OUTPUT lProfileExists ).

    IF lProfileExists THEN
    DO:
        ASSIGN rRowID = ?.

        RUN getProfileData IN gshProfileManager (
            INPUT "Browser",
            INPUT "Sorting",
            INPUT cProfileKey,
            INPUT NO,
            INPUT-OUTPUT rRowID,
            OUTPUT cProfileData ).

        IF ( cProfileData <> "" ) THEN
        DO:
            /* Get the column name. Remove the 'descending' keyword if present. */

            cColumnName = REPLACE( cProfileData, "descending", "" ).
            
            /* This has to do with the fact that an SBO does not have a sort API. Look at the
               'setSort' function in browser.p for the details. */

            IF ( cDataSourceNames <> ? ) AND ( cDataSourceNames <> "":U ) THEN
               hDataSource = {fnarg DataObjectHandle cDataSourceNames hDataSource}. 

            /* Set the Query Sort (BY phrase) and re-open the query. */

            IF VALID-HANDLE( hDataSource ) THEN
            DO:
                hBrowse:REFRESHABLE = NO.
                DYNAMIC-FUNCTION( "setQuerySort":U IN hDataSource, cProfileData ). 
                DYNAMIC-FUNCTION( "openQuery":U IN hDataSource ).
                hBrowse:REFRESHABLE = YES.
            END.
        END.
    END.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

/* ************************  Function Implementations ***************** */

&IF DEFINED(EXCLUDE-getBrowseColumnsMovable) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION getBrowseColumnsMovable Procedure 
FUNCTION getBrowseColumnsMovable RETURNS LOGICAL
  ( /* parameter-definitions */ ) :
/*------------------------------------------------------------------------------
  Purpose:  
    Notes:  
------------------------------------------------------------------------------*/

    DEFINE VARIABLE lMovable AS LOGICAL    NO-UNDO.

    {get BrowseColumnsMovable lMovable}.

    RETURN lMovable.

END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-getBrowsePopupActive) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION getBrowsePopupActive Procedure 
FUNCTION getBrowsePopupActive RETURNS LOGICAL
  ( ) :
/*------------------------------------------------------------------------------
  Purpose:  Returns the value of the BrowsePopupActive property.
------------------------------------------------------------------------------*/

    DEFINE VARIABLE lActive AS LOGICAL    NO-UNDO.

    {get BrowsePopupActive lActive}.
    RETURN lActive.

END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-setBrowseColumnsMovable) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION setBrowseColumnsMovable Procedure 
FUNCTION setBrowseColumnsMovable RETURNS LOGICAL
  ( INPUT plValue AS LOGICAL ):
/*------------------------------------------------------------------------------
  Purpose:  
    Notes:  
------------------------------------------------------------------------------*/

    {set BrowseColumnsMovable plValue}.

    RETURN TRUE.

END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-setBrowsePopupActive) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION setBrowsePopupActive Procedure 
FUNCTION setBrowsePopupActive RETURNS LOGICAL
  ( INPUT plActive AS LOGICAL ):
/*------------------------------------------------------------------------------
  Purpose:  Sets the BrowsePopupActive property.
------------------------------------------------------------------------------*/

    {set BrowsePopupActive plActive}.

    RETURN TRUE.
END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

