ROUTINE-LEVEL ON ERROR UNDO, THROW.                                /* 13 */

DEFINE VARIABLE TempCustNum     AS INTEGER NO-UNDO.
DEFINE VARIABLE CustCreditLimit AS DECIMAL NO-UNDO INITIAL ?.      /* 12 */

FUNCTION GetCreditLimit RETURNS DECIMAL ( ):
  /* Returns the credit limit of the current customer. If there is no current
     customer, it returns Unknown (?). */
  RETURN CustCreditLimit.
END FUNCTION.

FUNCTION SetCreditLimit RETURNS LOGICAL PRIVATE (INPUT iCL AS DECIMAL):
  /* Raise Credit Limit for Customers in good standing */
  /* Current increase is $1,000                        */
  IF Customer.Balance > iCL THEN DO:
    CustCreditLimit = Customer.Creditlimit.
    RETURN FALSE.                                                  /* 13 */
  END.
  ELSE DO:
    ASSIGN
      Customer.Creditlimit = iCL + 1000
      CustCreditLimit      = Customer.Creditlimit.
    RETURN TRUE.
  END.
END FUNCTION.

PROCEDURE SetCurrentCustomer:
  DEFINE INPUT PARAMETER iCustNum AS INTEGER NO-UNDO.

  FIND FIRST Customer WHERE Customer.CustNum = iCustNum NO-ERROR.  /* 15 */
END PROCEDURE.

PROCEDURE CheckCustCredit:
  IF AVAILABLE (Customer) THEN DO:
    IF SetCreditLimit (Customer.Creditlimit) THEN                  /* 12 */
      RETURN "Credit Good".
    ELSE 
      UNDO, THROW NEW Progress.Lang.AppError( "Over Limit" ).      /* 13 */
  END.
  ELSE
    UNDO, THROW NEW Progress.Lang.AppError( "No Customer" ).       /* 13 */
END PROCEDURE.
