/** This procedure drives the CustProc.p example **/               /* 10 */

/* Define iNumCusts as SHARED to illustrate the counterpart to PUBLIC data
   members in classes. */
DEFINE NEW SHARED VARIABLE iNumCusts AS INTEGER NO-UNDO.

DEFINE VARIABLE hCustProc    AS HANDLE    NO-UNDO.
DEFINE VARIABLE idx          AS INTEGER   NO-UNDO.
DEFINE VARIABLE piCustNum    AS INTEGER   NO-UNDO.
DEFINE VARIABLE pcCustName   AS CHARACTER NO-UNDO.
DEFINE VARIABLE pdtTimeStamp AS DATETIME  NO-UNDO.

DEFINE TEMP-TABLE ttCustNames NO-UNDO
  FIELD CustName AS CHARACTER.

RUN CustProc.p PERSISTENT SET hCustProc.
SUBSCRIBE TO "OutputGenerated" IN hCustProc.                       /* 16 */

RUN updateTimestamp IN hCustProc (OUTPUT pdtTimeStamp).            /* 4 */
MESSAGE "Initializing reports for all customers at" STRING(pdtTimeStamp)
  VIEW-AS ALERT-BOX.

DO idx = 1 TO iNumCusts:   
  CREATE ttCustNames.
  RUN GetCustomerName IN hCustProc(INPUT idx, OUTPUT pcCustName).
    ttCustNames.CustName = pcCustName.
END.

RUN CheckCredit IN hCustProc.

RUN printProc IN hCustProc (1).
RUN logProc IN hCustProc ("CustomersProc.out").
RUN CleanUp IN hCustProc.                                          /* 6 */

DELETE OBJECT hCustProc.

PROCEDURE OutputGenerated:                                         /* 16 */
  DEFINE INPUT PARAMETER pcOutputType AS CHARACTER NO-UNDO.
  MESSAGE pcOutputType "for all customers." VIEW-AS ALERT-BOX.
END PROCEDURE.