&ANALYZE-SUSPEND _VERSION-NUMBER UIB_v9r12 GUI
&ANALYZE-RESUME
/* Connected Databases 
          sports2000       PROGRESS
*/
&Scoped-define WINDOW-NAME CustWin
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS CustWin 
/*------------------------------------------------------------------------

  File: 

  Description: 

  Input Parameters:
      <none>

  Output Parameters:
      <none>

  Author: 

  Created: 

------------------------------------------------------------------------*/
/*          This .W file was created with the Progress AppBuilder.      */
/*----------------------------------------------------------------------*/

/* Create an unnamed pool to store all the widgets created 
     by this procedure. This is a good default which assures
     that this procedure's triggers and internal procedures 
     will execute in this procedure's storage, and that proper
     cleanup will occur on deletion of the procedure. */

CREATE WIDGET-POOL.

/* ***************************  Definitions  ************************** */

/* Parameters Definitions ---                                           */

/* Local Variable Definitions ---                                       */

DEFINE VARIABLE iQueryRow  AS INTEGER    NO-UNDO.

{h-ttOline.i}
/* DEFINE TEMP-TABLE ttOline LIKE Orderline
    FIELD ItemName LIKE ITEM.ItemName
    FIELD TotalWeight AS DECIMAL LABEL "Tot.Wgt." .  */

DEFINE QUERY OlineQuery FOR ttOline.

DEFINE BROWSE OlineBrowse
  QUERY OlineQuery NO-LOCK DISPLAY
      ttOline.Ordernum 
      ttOline.LineNum LABEL "Line"
      ttOline.ItemNum LABEL "Item" FORMAT "ZZZ9"
      ttOline.ItemName FORMAT "x(20)"
      ttOline.TotalWeight
      ttOline.Price FORMAT "ZZ,ZZ9.99"
      ttOline.Qty
      ttOline.Discount
      ttOline.ExtendedPrice LABEL "Ext.Price" FORMAT "ZZZ,ZZ9.99"
    ENABLE ttOline.Price ttOline.Qty ttOline.Discount 
    WITH MULTIPLE SEPARATORS 7 DOWN ROW-HEIGHT-CHARS .57.

DEFINE VARIABLE hBrowse AS HANDLE     NO-UNDO.
DEFINE BUFFER   ttOline2 FOR ttOline.

hBrowse = BROWSE OlineBrowse:HANDLE.
ON "ROW-LEAVE" OF BROWSE OlineBrowse
DO:
    IF hBrowse:NEW-ROW THEN
    DO:
        FIND LAST ttOline2. 
        CREATE ttOline.
        BUFFER-COPY ttOline2 TO ttOline 
            ASSIGN ttOline.LineNum = ttOline2.LineNum + 1.
        ASSIGN INPUT BROWSE OlineBrowse ttOline.Qty 
                 ttOline.Price ttOline.Discount.
        DISPLAY ttOline.OrderNum ttOline.LineNum 
                ttOline.ItemNum  ttOline.ItemName
                WITH BROWSE OlineBrowse.
        hBrowse:CREATE-RESULT-LIST-ENTRY().
    END.
END.

DEFINE VARIABLE iPromiseDays AS INTEGER    NO-UNDO.

DEFINE BUFFER   bOrder2    FOR Order.
DEFINE QUERY    qOrderDate FOR bOrder2 SCROLLING.
DEFINE VARIABLE lOrderDate AS LOGICAL    NO-UNDO.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE Window
&Scoped-define DB-AWARE no

/* Name of first Frame and/or Browse and/or first Query                 */
&Scoped-define FRAME-NAME CustQuery
&Scoped-define BROWSE-NAME OrderBrowse

/* Internal Tables (found by Frame, Query & Browse Queries)             */
&Scoped-define INTERNAL-TABLES Customer Order

/* Definitions for BROWSE OrderBrowse                                   */
&Scoped-define FIELDS-IN-QUERY-OrderBrowse Order.Ordernum Order.OrderDate ~
Order.PromiseDate Order.Creditcard Order.ShipDate ~
Order.PromiseDate - Order.OrderDate @ iPromiseDays Order.PO Order.BillToID ~
Order.Carrier Order.CustNum Order.Instructions Order.OrderStatus ~
Order.SalesRep Order.ShipToID Order.Terms Order.WarehouseNum 
&Scoped-define ENABLED-FIELDS-IN-QUERY-OrderBrowse Order.Creditcard ~
Order.PO 
&Scoped-define ENABLED-TABLES-IN-QUERY-OrderBrowse Order
&Scoped-define FIRST-ENABLED-TABLE-IN-QUERY-OrderBrowse Order
&Scoped-define QUERY-STRING-OrderBrowse FOR EACH Order OF Customer NO-LOCK INDEXED-REPOSITION
&Scoped-define OPEN-QUERY-OrderBrowse OPEN QUERY OrderBrowse FOR EACH Order OF Customer NO-LOCK INDEXED-REPOSITION.
&Scoped-define TABLES-IN-QUERY-OrderBrowse Order
&Scoped-define FIRST-TABLE-IN-QUERY-OrderBrowse Order


/* Definitions for FRAME CustQuery                                      */
&Scoped-define FIELDS-IN-QUERY-CustQuery Customer.CustNum Customer.Name ~
Customer.Address Customer.City Customer.State 
&Scoped-define ENABLED-FIELDS-IN-QUERY-CustQuery Customer.CustNum ~
Customer.Name Customer.Address Customer.City Customer.State 
&Scoped-define ENABLED-TABLES-IN-QUERY-CustQuery Customer
&Scoped-define FIRST-ENABLED-TABLE-IN-QUERY-CustQuery Customer
&Scoped-define OPEN-BROWSERS-IN-QUERY-CustQuery ~
    ~{&OPEN-QUERY-OrderBrowse}
&Scoped-define QUERY-STRING-CustQuery FOR EACH Customer ~
      WHERE Customer.State = "NH" SHARE-LOCK ~
    BY Customer.City
&Scoped-define OPEN-QUERY-CustQuery OPEN QUERY CustQuery FOR EACH Customer ~
      WHERE Customer.State = "NH" SHARE-LOCK ~
    BY Customer.City.
&Scoped-define TABLES-IN-QUERY-CustQuery Customer
&Scoped-define FIRST-TABLE-IN-QUERY-CustQuery Customer


/* Standard List Definitions                                            */
&Scoped-Define ENABLED-FIELDS Customer.CustNum Customer.Name ~
Customer.Address Customer.City Customer.State 
&Scoped-define ENABLED-TABLES Customer
&Scoped-define FIRST-ENABLED-TABLE Customer
&Scoped-Define ENABLED-OBJECTS BtnFirst BtnNext BtnPrev BtnLast ~
btnOrderDate OrderBrowse BtnTotal dTotal iorder cCreditCard btnNew ~
btnDelete 
&Scoped-Define DISPLAYED-FIELDS Customer.CustNum Customer.Name ~
Customer.Address Customer.City Customer.State 
&Scoped-define DISPLAYED-TABLES Customer
&Scoped-define FIRST-DISPLAYED-TABLE Customer
&Scoped-Define DISPLAYED-OBJECTS dTotal iorder cCreditCard 

/* Custom List Definitions                                              */
/* List-1,List-2,List-3,List-4,List-5,List-6                            */

/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME



/* ***********************  Control Definitions  ********************** */

/* Define the widget handle for the window                              */
DEFINE VAR CustWin AS WIDGET-HANDLE NO-UNDO.

/* Definitions of the field level widgets                               */
DEFINE BUTTON btnDelete 
     LABEL "Delete OrderLines" 
     SIZE 20 BY 1.14.

DEFINE BUTTON BtnFirst 
     LABEL "First" 
     SIZE 15 BY 1.14.

DEFINE BUTTON BtnLast 
     LABEL "Last" 
     SIZE 15 BY 1.14.

DEFINE BUTTON btnNew 
     LABEL "New OrderLine" 
     SIZE 18 BY 1.14.

DEFINE BUTTON BtnNext 
     LABEL "Next" 
     SIZE 15 BY 1.14.

DEFINE BUTTON btnOrderDate 
     LABEL "Show all on this Date" 
     SIZE 26 BY 1.14.

DEFINE BUTTON BtnPrev 
     LABEL "Prev" 
     SIZE 15 BY 1.14.

DEFINE BUTTON BtnTotal 
     LABEL "Total" 
     SIZE 14 BY 1.14.

DEFINE VARIABLE cCreditCard AS CHARACTER FORMAT "X(16)":U 
     VIEW-AS COMBO-BOX INNER-LINES 3
     LIST-ITEMS "American Express","Master Card","VISA" 
     DROP-DOWN-LIST
     SIZE 23 BY 1 NO-UNDO.

DEFINE VARIABLE dTotal AS DECIMAL FORMAT "->>,>>9.99":U INITIAL 0 
     VIEW-AS FILL-IN 
     SIZE 14 BY 1 NO-UNDO.

DEFINE VARIABLE iorder AS INTEGER FORMAT ">>>>9":U INITIAL 0 
     LABEL "Order" 
     VIEW-AS FILL-IN 
     SIZE 14 BY 1 NO-UNDO.

/* Query definitions                                                    */
&ANALYZE-SUSPEND
DEFINE QUERY OrderBrowse FOR 
      Order SCROLLING.

DEFINE QUERY CustQuery FOR 
      Customer SCROLLING.
&ANALYZE-RESUME

/* Browse definitions                                                   */
DEFINE BROWSE OrderBrowse
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _DISPLAY-FIELDS OrderBrowse CustWin _STRUCTURED
  QUERY OrderBrowse NO-LOCK DISPLAY
      Order.Ordernum FORMAT "zzzzzzzzz9":U WIDTH 10.2
      Order.OrderDate FORMAT "99/99/99":U
      Order.PromiseDate FORMAT "99/99/99":U
      Order.Creditcard FORMAT "x(20)":U WIDTH 22.2
      Order.ShipDate FORMAT "99/99/9999":U
      Order.PromiseDate - Order.OrderDate @ iPromiseDays COLUMN-LABEL "Promise!Days"
      Order.PO FORMAT "x(20)":U WIDTH 10.4
      Order.BillToID FORMAT "zzzzzzzzz9":U
      Order.Carrier FORMAT "x(25)":U
      Order.CustNum FORMAT ">>>>9":U
      Order.Instructions FORMAT "x(50)":U
      Order.OrderStatus FORMAT "x(20)":U
      Order.SalesRep FORMAT "x(4)":U
      Order.ShipToID FORMAT "zzzzzzzzz9":U
      Order.Terms FORMAT "x(20)":U
      Order.WarehouseNum FORMAT "zzzzzzzzz9":U
  ENABLE
      Order.Creditcard
      Order.PO
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
    WITH NO-ROW-MARKERS SEPARATORS SIZE 67 BY 6.19 ROW-HEIGHT-CHARS .7 EXPANDABLE.


/* ************************  Frame Definitions  *********************** */

DEFINE FRAME CustQuery
     BtnFirst AT ROW 1.48 COL 8
     BtnNext AT ROW 1.48 COL 24.6
     BtnPrev AT ROW 1.48 COL 41.2
     BtnLast AT ROW 1.48 COL 58
     Customer.CustNum AT ROW 3.38 COL 13.4 COLON-ALIGNED
          VIEW-AS FILL-IN 
          SIZE 9 BY 1
     Customer.Name AT ROW 3.38 COL 37 COLON-ALIGNED
          VIEW-AS FILL-IN 
          SIZE 32 BY 1
     Customer.Address AT ROW 4.57 COL 13 COLON-ALIGNED
          VIEW-AS FILL-IN 
          SIZE 37 BY 1
     Customer.City AT ROW 5.76 COL 13 COLON-ALIGNED
          VIEW-AS FILL-IN 
          SIZE 27 BY 1
     Customer.State AT ROW 5.76 COL 47 COLON-ALIGNED
          VIEW-AS FILL-IN 
          SIZE 22 BY 1
     btnOrderDate AT ROW 6 COL 76
     OrderBrowse AT ROW 7.67 COL 13
     BtnTotal AT ROW 7.67 COL 89
     dTotal AT ROW 9.33 COL 87 COLON-ALIGNED NO-LABEL
     iorder AT ROW 12.43 COL 87 COLON-ALIGNED
     cCreditCard AT ROW 16 COL 36 COLON-ALIGNED NO-LABEL
     btnNew AT ROW 21 COL 3
     btnDelete AT ROW 21 COL 23
    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY 
         SIDE-LABELS NO-UNDERLINE THREE-D 
         AT COL 1 ROW 1
         SIZE 104.4 BY 21.33.


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: Window
   Allow: Basic,Browse,DB-Fields,Window,Query
   Other Settings: COMPILE
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
IF SESSION:DISPLAY-TYPE = "GUI":U THEN
  CREATE WINDOW CustWin ASSIGN
         HIDDEN             = YES
         TITLE              = "Customers and Orders"
         HEIGHT             = 21.33
         WIDTH              = 104.4
         MAX-HEIGHT         = 22.43
         MAX-WIDTH          = 189.2
         VIRTUAL-HEIGHT     = 22.43
         VIRTUAL-WIDTH      = 189.2
         RESIZE             = yes
         SCROLL-BARS        = no
         STATUS-AREA        = no
         BGCOLOR            = ?
         FGCOLOR            = ?
         KEEP-FRAME-Z-ORDER = yes
         THREE-D            = yes
         MESSAGE-AREA       = no
         SENSITIVE          = yes.
ELSE {&WINDOW-NAME} = CURRENT-WINDOW.
/* END WINDOW DEFINITION                                                */
&ANALYZE-RESUME



/* ***********  Runtime Attributes and AppBuilder Settings  *********** */

&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES
/* SETTINGS FOR WINDOW CustWin
  VISIBLE,,RUN-PERSISTENT                                               */
/* SETTINGS FOR FRAME CustQuery
                                                                        */
/* BROWSE-TAB OrderBrowse btnOrderDate CustQuery */
ASSIGN 
       cCreditCard:HIDDEN IN FRAME CustQuery           = TRUE.

ASSIGN 
       OrderBrowse:NUM-LOCKED-COLUMNS IN FRAME CustQuery     = 2.

IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(CustWin)
THEN CustWin:HIDDEN = no.

/* _RUN-TIME-ATTRIBUTES-END */
&ANALYZE-RESUME


/* Setting information for Queries and Browse Widgets fields            */

&ANALYZE-SUSPEND _QUERY-BLOCK FRAME CustQuery
/* Query rebuild information for FRAME CustQuery
     _TblList          = "Sports2000.Customer"
     _OrdList          = "Sports2000.Customer.City|yes"
     _Where[1]         = "Customer.State = ""NH"""
     _Query            is OPENED
*/  /* FRAME CustQuery */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _QUERY-BLOCK BROWSE OrderBrowse
/* Query rebuild information for BROWSE OrderBrowse
     _TblList          = "sports2000.Order OF sports2000.Customer"
     _Options          = "NO-LOCK INDEXED-REPOSITION"
     _FldNameList[1]   > sports2000.Order.Ordernum
"Order.Ordernum" ? ? "integer" ? ? ? ? ? ? no ? no no "10.2" yes no no "U" "" ""
     _FldNameList[2]   = sports2000.Order.OrderDate
     _FldNameList[3]   = sports2000.Order.PromiseDate
     _FldNameList[4]   > Sports2000.Order.Creditcard
"Order.Creditcard" ? ? "character" ? ? ? ? ? ? yes ? no no "22.2" yes no no "U" "" ""
     _FldNameList[5]   = sports2000.Order.ShipDate
     _FldNameList[6]   > "_<CALC>"
"Order.PromiseDate - Order.OrderDate @ iPromiseDays" "Promise!Days" ? ? ? ? ? ? ? ? no ? no no ? yes no no "U" "" ""
     _FldNameList[7]   > sports2000.Order.PO
"Order.PO" ? ? "character" ? ? ? ? ? ? yes ? no no "10.4" yes no no "U" "" ""
     _FldNameList[8]   = Sports2000.Order.BillToID
     _FldNameList[9]   = Sports2000.Order.Carrier
     _FldNameList[10]   = Sports2000.Order.CustNum
     _FldNameList[11]   = Sports2000.Order.Instructions
     _FldNameList[12]   = Sports2000.Order.OrderStatus
     _FldNameList[13]   = Sports2000.Order.SalesRep
     _FldNameList[14]   = Sports2000.Order.ShipToID
     _FldNameList[15]   = Sports2000.Order.Terms
     _FldNameList[16]   = Sports2000.Order.WarehouseNum
     _Query            is OPENED
*/  /* BROWSE OrderBrowse */
&ANALYZE-RESUME

 



/* ************************  Control Triggers  ************************ */

&Scoped-define SELF-NAME CustWin
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL CustWin CustWin
ON END-ERROR OF CustWin /* Customers and Orders */
OR ENDKEY OF {&WINDOW-NAME} ANYWHERE DO:
  /* This case occurs when the user presses the "Esc" key.
     In a persistently run window, just ignore this.  If we did not, the
     application would exit. */
  IF THIS-PROCEDURE:PERSISTENT THEN RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL CustWin CustWin
ON WINDOW-CLOSE OF CustWin /* Customers and Orders */
DO:
  /* This event will close the window and terminate the procedure.  */
  APPLY "CLOSE":U TO THIS-PROCEDURE.
  RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME btnDelete
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL btnDelete CustWin
ON CHOOSE OF btnDelete IN FRAME CustQuery /* Delete OrderLines */
DO:
  DEFINE VARIABLE iRow AS INTEGER    NO-UNDO.
  DO iRow = 1 TO hBrowse:NUM-SELECTED-ROWS:
      hBrowse:FETCH-SELECTED-ROW(iRow).
      DELETE ttOline.
  END.
  hBrowse:DELETE-SELECTED-ROWS().
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME BtnFirst
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL BtnFirst CustWin
ON CHOOSE OF BtnFirst IN FRAME CustQuery /* First */
DO:
  {h-ButtonTrig2.i FIRST}
  /* GET FIRST CustQuery.
  IF AVAILABLE Customer THEN 
    DISPLAY Customer.CustNum Customer.Name Customer.Address Customer.City 
          Customer.State 
      WITH FRAME CustQuery IN WINDOW CustWin.
  {&OPEN-BROWSERS-IN-QUERY-CustQuery}
  APPLY "VALUE-CHANGED" TO OrderBrowse. */
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME BtnLast
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL BtnLast CustWin
ON CHOOSE OF BtnLast IN FRAME CustQuery /* Last */
DO:
    {h-ButtonTrig2.i LAST}
  /* GET LAST CustQuery.
  IF AVAILABLE Customer THEN 
    DISPLAY Customer.CustNum Customer.Name Customer.Address Customer.City 
          Customer.State 
      WITH FRAME CustQuery IN WINDOW CustWin.
  {&OPEN-BROWSERS-IN-QUERY-CustQuery}
  APPLY "VALUE-CHANGED" TO OrderBrowse. */
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME btnNew
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL btnNew CustWin
ON CHOOSE OF btnNew IN FRAME CustQuery /* New OrderLine */
DO:
    IF hBrowse:NUM-SELECTED-ROWS = 0 THEN
    DO:
       APPLY "END" TO hBrowse.
       hBrowse:SELECT-FOCUSED-ROW().
    END.
    hBrowse:INSERT-ROW("AFTER"). 
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME BtnNext
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL BtnNext CustWin
ON CHOOSE OF BtnNext IN FRAME CustQuery /* Next */
DO:
    {h-ButtonTrig2.i NEXT}
  /* GET NEXT CustQuery.
  IF AVAILABLE Customer THEN 
    DISPLAY Customer.CustNum Customer.Name Customer.Address Customer.City 
          Customer.State 
      WITH FRAME CustQuery IN WINDOW CustWin.
  {&OPEN-BROWSERS-IN-QUERY-CustQuery}
  APPLY "VALUE-CHANGED" TO OrderBrowse. */
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME btnOrderDate
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL btnOrderDate CustWin
ON CHOOSE OF btnOrderDate IN FRAME CustQuery /* Show all on this Date */
DO:
    IF NOT lOrderDate THEN
    DO:
        /* If the standard query is displayed, open the query for 
           Orderdates and make that the browse's query. 
           Hide the OrderLine browse while we're
           doing this, and adjust the button label accordingly. */
        OPEN QUERY qOrderDate FOR EACH bOrder2
          WHERE bOrder2.OrderDate = Order.OrderDate.
        ASSIGN BROWSE OrderBrowse:QUERY = QUERY qOrderDate:HANDLE
               /* Signal that we're showing the OrderDate query. */
               lOrderDate = TRUE
               hBrowse:HIDDEN = TRUE
               SELF:LABEL = "Show Customer's Orders".
    END.
    ELSE
        /* If we're showing the OrderDate query, switch back to the
           regular query for the current Customer's Orders. */
        ASSIGN BROWSE OrderBrowse:QUERY = QUERY OrderBrowse:HANDLE
                      lOrderDate = FALSE
                      hBrowse:HIDDEN = FALSE
                      SELF:LABEL = "Show all on this Date".
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME BtnPrev
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL BtnPrev CustWin
ON CHOOSE OF BtnPrev IN FRAME CustQuery /* Prev */
DO:
    {h-ButtonTrig2.i PREV}
  /* GET PREV CustQuery.
  IF AVAILABLE Customer THEN 
    DISPLAY Customer.CustNum Customer.Name Customer.Address Customer.City 
          Customer.State 
      WITH FRAME CustQuery IN WINDOW CustWin.
  {&OPEN-BROWSERS-IN-QUERY-CustQuery}
  APPLY "VALUE-CHANGED" TO OrderBrowse. */
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME BtnTotal
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL BtnTotal CustWin
ON CHOOSE OF BtnTotal IN FRAME CustQuery /* Total */
DO:
    DEFINE VARIABLE iRow    AS INTEGER    NO-UNDO.
    DEFINE VARIABLE hBrowse AS HANDLE     NO-UNDO.
    
    hBrowse = BROWSE OlineBrowse:HANDLE.
    
    DO iRow = 1 TO hBrowse:NUM-SELECTED-ROWS:
      hBrowse:FETCH-SELECTED-ROW(iRow).
      dTotal = dTotal + ttOline.ExtendedPrice.
    END.
    DISPLAY dtotal WITH FRAME CustQuery.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME cCreditCard
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL cCreditCard CustWin
ON ENTRY OF cCreditCard IN FRAME CustQuery
DO:
  SELF:VISIBLE = TRUE.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL cCreditCard CustWin
ON VALUE-CHANGED OF cCreditCard IN FRAME CustQuery
DO:
  cCreditCard:VISIBLE IN FRAME CustQuery = FALSE.
  CreditCard:SCREEN-VALUE IN BROWSE OrderBrowse = 
      cCreditCard:SCREEN-VALUE.
  APPLY "ENTRY" TO CreditCard IN BROWSE OrderBrowse.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME iorder
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL iorder CustWin
ON LEAVE OF iorder IN FRAME CustQuery /* Order */
DO:
  BROWSE OrderBrowse:SET-REPOSITIONED-ROW(3, "CONDITIONAL").
  ASSIGN iOrder.
  FIND Order WHERE order.orderNum = iOrder NO-ERROR.
  IF AVAILABLE (Order) THEN
      REPOSITION  OrderBrowse TO ROWID ROWID(Order) NO-ERROR.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define BROWSE-NAME OrderBrowse
&Scoped-define SELF-NAME OrderBrowse
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL OrderBrowse CustWin
ON DEFAULT-ACTION OF OrderBrowse IN FRAME CustQuery
DO:
/*   MESSAGE "This Order's SalesRep is " Order.SalesRep SKIP     */
/*           "and the terms are " Order.Terms VIEW-AS ALERT-BOX. */
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL OrderBrowse CustWin
ON SCROLL-NOTIFY OF OrderBrowse IN FRAME CustQuery
DO:
  RUN placeCombo.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL OrderBrowse CustWin
ON START-SEARCH OF OrderBrowse IN FRAME CustQuery
DO:
  DEFINE VARIABLE hColumn AS HANDLE     NO-UNDO.
  DEFINE VARIABLE iColumn AS INTEGER    NO-UNDO.
  hColumn = SELF:FIRST-COLUMN.
  DO iColumn = 1 TO SELF:NUM-COLUMNS:
      IF hColumn = SELF:CURRENT-COLUMN THEN LEAVE.
      hColumn = hColumn:NEXT-COLUMN.
  END.
  IF iColumn NE 1 THEN 
      SELF:MOVE-COLUMN(iColumn, iColumn - 1).
  RUN placeCombo.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL OrderBrowse CustWin
ON VALUE-CHANGED OF OrderBrowse IN FRAME CustQuery
DO:
  RUN h-fetchOlines.p (INPUT Order.OrderNum, OUTPUT TABLE ttOline).
  OPEN QUERY OlineQuery FOR EACH ttOline.
  DISPLAY OlineBrowse AT ROW 14 COLUMN 5 WITH FRAME CustQuery.
  ENABLE OlineBrowse WITH FRAME CustQuery.
  
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME Order.Creditcard
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL Order.Creditcard OrderBrowse _BROWSE-COLUMN CustWin
ON ENTRY OF Order.Creditcard IN BROWSE OrderBrowse /* Credit Card */
DO:
  RUN placeCombo.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL Order.Creditcard OrderBrowse _BROWSE-COLUMN CustWin
ON LEAVE OF Order.Creditcard IN BROWSE OrderBrowse /* Credit Card */
DO:
   cCreditCard:VISIBLE IN FRAME CustQuery = FALSE.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME Order.PO
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL Order.PO OrderBrowse _BROWSE-COLUMN CustWin
ON LEAVE OF Order.PO IN BROWSE OrderBrowse /* PO */
DO:
  IF SELF:SCREEN-VALUE BEGINS "X" then
      SELF:BGCOLOR = 12. /* RED */
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&UNDEFINE SELF-NAME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK CustWin 


/* ***************************  Main Block  *************************** */

/* Set CURRENT-WINDOW: this will parent dialog-boxes and frames.        */
ASSIGN CURRENT-WINDOW                = {&WINDOW-NAME} 
       THIS-PROCEDURE:CURRENT-WINDOW = {&WINDOW-NAME}.

/* The CLOSE event can be used from inside or outside the procedure to  */
/* terminate it.                                                        */
ON CLOSE OF THIS-PROCEDURE 
   RUN disable_UI.

/* Best default for GUI applications is...                              */
PAUSE 0 BEFORE-HIDE.

/* Now enable the interface and wait for the exit condition.            */
/* (NOTE: handle ERROR and END-KEY so cleanup code will always fire.    */
MAIN-BLOCK:
DO ON ERROR   UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK
   ON END-KEY UNDO MAIN-BLOCK, LEAVE MAIN-BLOCK:
  RUN enable_UI.
  cCreditCard:HIDDEN = TRUE.
  APPLY "VALUE-CHANGED" TO OrderBrowse.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI CustWin  _DEFAULT-DISABLE
PROCEDURE disable_UI :
/*------------------------------------------------------------------------------
  Purpose:     DISABLE the User Interface
  Parameters:  <none>
  Notes:       Here we clean-up the user-interface by deleting
               dynamic widgets we have created and/or hide 
               frames.  This procedure is usually called when
               we are ready to "clean-up" after running.
------------------------------------------------------------------------------*/
  /* Delete the WINDOW we created */
  IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(CustWin)
  THEN DELETE WIDGET CustWin.
  IF THIS-PROCEDURE:PERSISTENT THEN DELETE PROCEDURE THIS-PROCEDURE.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI CustWin  _DEFAULT-ENABLE
PROCEDURE enable_UI :
/*------------------------------------------------------------------------------
  Purpose:     ENABLE the User Interface
  Parameters:  <none>
  Notes:       Here we display/view/enable the widgets in the
               user-interface.  In addition, OPEN all queries
               associated with each FRAME and BROWSE.
               These statements here are based on the "Other 
               Settings" section of the widget Property Sheets.
------------------------------------------------------------------------------*/

  {&OPEN-QUERY-CustQuery}
  GET FIRST CustQuery.
  DISPLAY dTotal iorder cCreditCard 
      WITH FRAME CustQuery IN WINDOW CustWin.
  IF AVAILABLE Customer THEN 
    DISPLAY Customer.CustNum Customer.Name Customer.Address Customer.City 
          Customer.State 
      WITH FRAME CustQuery IN WINDOW CustWin.
  ENABLE BtnFirst BtnNext BtnPrev BtnLast Customer.CustNum Customer.Name 
         Customer.Address Customer.City Customer.State btnOrderDate OrderBrowse 
         BtnTotal dTotal iorder cCreditCard btnNew btnDelete 
      WITH FRAME CustQuery IN WINDOW CustWin.
  {&OPEN-BROWSERS-IN-QUERY-CustQuery}
  VIEW CustWin.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE placeCombo CustWin 
PROCEDURE placeCombo :
/*------------------------------------------------------------------------------
  Purpose:    Positions the CreditCard combo box on top of the selected
              cell in the OrderBrowse and makes it visible. 
  Parameters:  <none>
------------------------------------------------------------------------------*/

DEFINE VARIABLE hCredit AS HANDLE     NO-UNDO.

hCredit = CreditCard:HANDLE IN BROWSE OrderBrowse.
IF hCredit:X < 0 OR hCredit:Y < 0 THEN /* Column not on screen */
    cCreditCard:VISIBLE IN FRAME CustQuery = FALSE.
ELSE DO: 
    ASSIGN cCreditCard:X IN FRAME CustQuery = hCredit:X + OrderBrowse:X
           cCreditCard:Y IN FRAME CustQuery = hCredit:Y + OrderBrowse:Y
           cCreditCard:SCREEN-VALUE = CreditCard:SCREEN-VALUE
           cCreditCard:VISIBLE IN FRAME CustQuery = TRUE.
           cCreditCard:MOVE-TO-TOP().
END.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

