/* h-FindUseful.p - Searches for a persistent procedure with a useful
   routine to run. */

DEFINE VARIABLE hProc   AS HANDLE     NO-UNDO.
DEFINE VARIABLE hUseful AS HANDLE     NO-UNDO.

RUN h-UsefulProc.p PERSISTENT SET hUseful.
hProc = SESSION:FIRST-PROCEDURE.

DO WHILE VALID-HANDLE(hProc):
  IF LOOKUP ("UsefulRoutine1", hProc:INTERNAL-ENTRIES) NE 0 THEN DO:
    RUN UsefulRoutine1 IN hProc.
    LEAVE.
  END.
  hProc = hProc:NEXT-SIBLING.
END.

DELETE PROCEDURE hUseful.
