/* h-StartSuper.p -- starts a super procedure if not already running, and
   returns its handle. */

DEFINE INPUT PARAMETER cProcName AS CHARACTER  NO-UNDO.

DEFINE VARIABLE hProc AS HANDLE     NO-UNDO.

/* Try to locate an instance of the procedure already running. */
hProc = SESSION:FIRST-PROCEDURE.
DO WHILE VALID-HANDLE(hProc):
  IF hProc:FILE-NAME = cProcName THEN LEAVE. /* Found it. */
  hProc = hProc:NEXT-SIBLING.
END.

/* If it wasn't found, then run it. */
IF NOT VALID-HANDLE(hProc) THEN
  RUN VALUE(cProcName) PERSISTENT SET hProc.

/* In either case, add it as a super procedure of the caller. */
SOURCE-PROCEDURE:ADD-SUPER-PROCEDURE(hProc, SEARCH-TARGET).
