{lt-10-in.i} /* Common Interface Setup Code */  
  
/**********  DEFINE TRIGGERS  **********/
ON CHOOSE of b-rep DO:  
  DEFINE VARIABLE Holder AS CHARACTER FORMAT "x(25)".

  DEFINE FRAME f-body
    Customer.Name NO-LABEL
    Customer.Balance AT 40 FORMAT "$zzz,zz9.99 CR" SKIP
    Customer.Contact
    Customer.CreditLimit AT 40 FORMAT "$zzz,zz9.99 CR" SKIP
    Customer.Address NO-LABEL SKIP
    Holder NO-LABEL SKIP
    Customer.Phone SKIP(2)
    WITH SIDE-LABELS STREAM-IO.
    
  OUTPUT TO "tut-temp.txt" PAGE-SIZE 25.
  FOR EACH Customer FIELDS(Balance SalesRep Name Contact CreditLimit
    Address City State PostalCode Phone) NO-LOCK
    WHERE Customer.Balance >= 1400 BREAK BY Customer.SalesRep:
    
    DEFINE FRAME f-hdr HEADER
      "Date:" TODAY "Customer Report" AT 25
      Customer.SalesRep AT 55
      "Page" AT 65
      PAGE-NUMBER FORMAT ">>9" SKIP(1)
      WITH PAGE-TOP FRAME f-hdr STREAM-IO.

    DEFINE FRAME f-ftr HEADER 
      "Customer Report"
      "continued next page"
      WITH FRAME f-ftr PAGE-BOTTOM CENTERED STREAM-IO.
            
    VIEW FRAME f-hdr.
    VIEW FRAME f-ftr.
    DISPLAY Customer.Name Customer.Balance Customer.Contact Customer.CreditLimit 
      Customer.Address
      (Customer.City + ", " + Customer.State + ", " + Customer.PostalCode) @ Holder 
      Customer.Phone WITH FRAME f-body.
            
    IF LAST-OF(Customer.SalesRep) THEN DO:
      HIDE FRAME f-ftr.
      PAGE.
    END.
  END.
  OUTPUT CLOSE.
    
  ASSIGN 
    Rep-Editor:READ-ONLY IN FRAME Dialog1 = TRUE
    Rep-Editor:SENSITIVE IN FRAME Dialog1 = TRUE
    FRAME Dialog1:TITLE                   = "Report Output"
    lStat = Rep-Editor:READ-FILE("tut-temp.txt") IN FRAME Dialog1. 
             
  IF lStat THEN DO:
    ENABLE Rep-Editor b-ok WITH FRAME Dialog1.
    WAIT-FOR GO OF FRAME Dialog1.
    HIDE FRAME Dialog1.
  END.
END.

/**********  MAIN LOGIC  **********/
ENABLE ALL WITH FRAME Frame1.
WAIT-FOR CHOOSE OF b-exit.
