/* i-sktsv1.p */

DEFINE VARIABLE aOk           AS LOGICAL   NO-UNDO.
DEFINE VARIABLE cString       AS CHARACTER NO-UNDO.
DEFINE VARIABLE greeting      AS CHARACTER NO-UNDO.
DEFINE VARIABLE hServerSocket AS HANDLE    NO-UNDO.
DEFINE VARIABLE hSocket       AS HANDLE    NO-UNDO.
DEFINE VARIABLE mBuffer       AS MEMPTR    NO-UNDO.

MESSAGE "We are in the socket server".
CREATE SERVER-SOCKET hServerSocket.

/* Marshal data to write */
ASSIGN
  SET-SIZE(mBuffer)     = 64
  greeting              = "SERVER - hello"
  PUT-STRING(mBuffer,1) = greeting.

MESSAGE "Start event handling".
hServerSocket:SET-CONNECT-PROCEDURE("connProc").
aOk = hServerSocket:ENABLE-CONNECTIONS("-S 3333").
MESSAGE "Enabled connections:" aOk.
IF NOT aOk THEN RETURN.

/* This WAIT-FOR completes after the first connection */
WAIT-FOR CONNECT OF hServerSocket.

MESSAGE "Freeing up resources".
hServerSocket:DISABLE-CONNECTIONS().
DELETE OBJECT hServerSocket.
MESSAGE "Finished".

PROCEDURE connProc:
  /* Connection procedure for server socket */
  DEFINE INPUT PARAMETER hSocket AS HANDLE.  /*Socket implicitly created*/

  IF VALID-HANDLE(hSocket) THEN DO: /* standard validation */
    MESSAGE "We are in CONNECT event procedure, connProc".
    hSocket:WRITE(mBuffer,1,LENGTH(greeting)).
    MESSAGE hSocket:BYTES-WRITTEN "bytes written".
    hSocket:DISCONNECT().
    DELETE OBJECT hSocket.
  END.
  ELSE MESSAGE "Unable to obtain socket.".
END PROCEDURE.

MESSAGE "We are in socket client".
CREATE SOCKET hSocket.
hSocket:CONNECT ("-H localhost -S 3333").
IF hSocket:CONNECTED() THEN
  MESSAGE "Connected OK".
ELSE DO:
  MESSAGE "Could not connect".
  RETURN.
END.

/* Do READ-RESPONSE event handling */
MESSAGE "Start event handling".
hSocket:SET-READ-RESPONSE-PROCEDURE("readProc").

/* This WAIT-FOR completes after the first data reception */
WAIT-FOR READ-RESPONSE OF hSocket.
  
MESSAGE "Freeing up resources".
hSocket:DISCONNECT().
DELETE OBJECT hSocket.
MESSAGE "Finished".

PROCEDURE readProc:
  /* Read procedure for socket */
  DEFINE VARIABLE mBuffer AS MEMPTR NO-UNDO.
     
  MESSAGE "We are in READ-RESPONSE event procedure, readProc".
  SET-SIZE(mBuffer) = 64.
  SELF:READ(mBuffer,1,SELF:GET-BYTES-AVAILABLE()).
  MESSAGE SELF:BYTES-READ "bytes read".
  cString = GET-STRING(mBuffer,1).  /* Unmarshal data */
  DISPLAY cString FORMAT "x(64)".
END PROCEDURE.
