DEFINE VARIABLE method-return AS LOGICAL NO-UNDO.

DEFINE QUERY q1 FOR Customer SCROLLING.

DEFINE BROWSE b1 QUERY q1 NO-LOCK 
  DISPLAY Customer.CustNum Customer.Name Customer.Phone 
  ENABLE Customer.Name Customer.Phone 
  WITH 15 DOWN NO-ASSIGN SEPARATORS.

DEFINE BUTTON button1 LABEL "New Row".

DEFINE FRAME f1 
  SKIP(1) SPACE(8) b1 SKIP(1) SPACE(8) button1
  WITH NO-BOX.

ON ROW-LEAVE OF b1 IN FRAME f1 DO: /* No-Assign Browser */
  /* If new row, create record and assign values in browse. */
  IF b1:NEW-ROW THEN DO:
    CREATE Customer.
    ASSIGN INPUT BROWSE b1 Customer.Name Customer.Phone.
    DISPLAY Customer.CustNum WITH BROWSE b1.
    method-return = b1:CREATE-RESULT-LIST-ENTRY().
    RETURN.
  END.
  /* If record exists and was changed in browse, update it. */
  IF BROWSE b1:CURRENT-ROW-MODIFIED THEN DO:
    GET CURRENT q1 EXCLUSIVE-LOCK.
    IF CURRENT-CHANGED Customer THEN DO:
      MESSAGE "This record has been changed by another user." SKIP
        "Please re-enter your changes.".
      DISPLAY Customer.CustNum Customer.Name Customer.Phone WITH BROWSE b1.
      RETURN NO-APPLY.
    END.
    ELSE /* Record is the same, so update it with exclusive-lock */
      ASSIGN INPUT BROWSE b1 Customer.Name Customer.Phone.
      /* Downgrade the lock to a no-lock. */
      GET CURRENT q1 NO-LOCK.
  END.
END.

ON CHOOSE OF button1 IN FRAME f1 DO: /* Insert */
  method-return = b1:INSERT-ROW("AFTER").
END.

OPEN QUERY q1 FOR EACH Customer.
ENABLE ALL WITH FRAME f1.
WAIT-FOR WINDOW-CLOSE OF CURRENT-WINDOW.
