/* r-chose1.p */

DEFINE VARIABLE counter   AS INTEGER   NO-UNDO.
DEFINE VARIABLE oldchoice AS CHARACTER NO-UNDO.

FORM Customer.CustNum Customer.Name Customer.Address Customer.City
  WITH FRAME cust-frame SCROLL 1 5 DOWN ATTR-SPACE.

FIND FIRST Customer NO-LOCK.

REPEAT counter = 1 TO 5:
  DISPLAY Customer.CustNum Customer.Name Customer.Address Customer.City 
    WITH FRAME cust-frame.
  DOWN WITH FRAME cust-frame.
  FIND NEXT Customer NO-LOCK NO-ERROR.
  IF NOT AVAILABLE customer THEN LEAVE.
END.
UP 5 WITH FRAME cust-frame.
oldchoice = "".

REPEAT:
  STATUS DEFAULT "Enter C to create, D to delete".
  CHOOSE ROW Customer.CustNum NO-ERROR GO-ON(CURSOR-RIGHT) 
    WITH FRAME cust-frame.

  /* After choice */
  IF FRAME-VALUE = "" THEN NEXT.

  /* Force user to press END or move cursor to valid line */
  IF FRAME-VALUE <> oldchoice THEN DO:
    oldchoice = FRAME-VALUE.
    FIND Customer WHERE Customer.CustNum = INTEGER(FRAME-VALUE).
  END.

  /* React to moving cursor off the screen */
  IF LASTKEY = KEYCODE("CURSOR-DOWN") THEN DO:
    FIND NEXT customer NO-ERROR.
    IF NOT AVAILABLE Customer THEN 
      FIND FIRST Customer NO-LOCK.
    DOWN WITH FRAME cust-frame.
    DISPLAY Customer.CustNum Customer.Name Customer.Address Customer.City
      WITH FRAME cust-frame.
    NEXT.
  END. /* KEYCODE("CURSOR-DOWN") */

  IF LASTKEY = KEYCODE("CURSOR-UP") THEN DO:
    FIND PREV Customer NO-LOCK NO-ERROR.
    IF NOT AVAILABLE Customer THEN 
      FIND LAST Customer NO-LOCK.
    UP WITH FRAME cust-frame.
    DISPLAY Customer.CustNum Customer.Name Customer.Address Customer.City
      WITH FRAME cust-frame.
    NEXT.
  END. /* KEYCODE("CURSOR-UP") */

  /* CHOOSE selected a valid key. Check which key. */
  IF LASTKEY = KEYCODE("c") THEN DO: /* Open a space in the frame. */
    SCROLL FROM-CURRENT DOWN WITH FRAME cust-frame.
    CREATE Customer.
    UPDATE Customer.CustNum Customer.Name Customer.Address Customer.City 
      WITH FRAME cust-frame.
    oldchoice = INPUT Customer.CustNum.
    NEXT.
  END. /* KEYCODE("c") */

  IF LASTKEY = KEYCODE("d") THEN DO: /* Delete a Customer. */
    DELETE Customer.
    FIND NEXT Customer NO-ERROR.
    /* Move to correct position in database. */
    IF NOT AVAILABLE Customer THEN DO:
      FIND FIRST Customer NO-ERROR.
      IF NOT AVAILABLE Customer THEN DO:
        CLEAR FRAME cust-frame.
        UP WITH FRAME cust-frame.
        NEXT.
      END.
    END.

    /* If last screen line deleted */
    IF FRAME-LINE(cust-frame) = FRAME-DOWN(cust-frame) THEN DO:/* 
      DISPLAY Customer.CustNum Customer.Name Customer.Address Customer.City
        WITH FRAME cust-frame.
      NEXT.
    END.

    SCROLL FROM-CURRENT WITH FRAME cust-frame.
    REPEAT counter = 1 TO 100
      WHILE FRAME-LINE(cust-frame) < FRAME-DOWN(cust-frame):
      FIND NEXT Customer NO-ERROR.
      IF NOT AVAILABLE Customer THEN DO:
        FIND FIRST Customer NO-ERROR.
        IF NOT AVAILABLE Customer THEN LEAVE.
      END.
      DOWN WITH FRAME cust-frame.
      IF INPUT Customer.CustNum = "" THEN 
        DISPLAY Customer.CustNum Customer.Name Customer.Address
          Customer.City WITH FRAME cust-frame.
    END.
    UP counter - 1 WITH FRAME cust-frame.
    oldchoice = INPUT Customer.CustNum.
  END. /* KEYCODE("d") */
END. /* REPEAT */

STATUS DEFAULT.
