/* r-chose2.p */

DEFINE VARIABLE counter   AS INTEGER   NO-UNDO.
DEFINE VARIABLE oldchoice AS CHARACTER NO-UNDO.

FORM Customer.CustNum Customer.Name Customer.Address Customer.City 
  WITH FRAME cust-frame SCROLL 1 5 DOWN ATTR-SPACE.

FIND FIRST Customer.
REPEAT COUNTER = 1 TO 5:
  DISPLAY Customer.CustNum Customer.Name Customer.Address Customer.City 
    WITH FRAME cust-frame.
  DOWN WITH FRAME cust-frame.
  FIND NEXT Customer NO-ERROR.
  IF NOT AVAILABLE Customer THEN LEAVE.
END.
UP 5 WITH FRAME cust-frame.
oldchoice = "".

REPEAT:
  STATUS DEFAULT "Use UP & DOWN ARROWS then enter C to create, D to delete".
  CHOOSE ROW Customer.CustNum NO-ERROR GO-ON(CURSOR-RIGHT)
    WITH FRAME cust-frame.

  /* After choice */
  /* Force user to press END or move cursor to valid line */
  IF FRAME-VALUE = "" THEN NEXT.   
  IF FRAME-VALUE <> oldchoice THEN DO:
    oldchoice = FRAME-VALUE.
    FIND Customer WHERE Customer.CustNum = INTEGER(FRAME-VALUE).
  END.

  /* React to moving cursor off the screen */
  IF LASTKEY = KEYCODE("CURSOR-DOWN") THEN DO:
    FIND NEXT Customer NO-ERROR.
    IF NOT AVAILABLE Customer THEN 
      FIND FIRST Customer.
    DOWN WITH FRAME cust-frame.
    DISPLAY Customer.CustNum Customer.Name Customer.Address Customer.City 
      WITH FRAME cust-frame.
    NEXT.
  END.

  IF LASTKEY = KEYCODE("CURSOR-UP") THEN DO:
    FIND PREV Customer NO-ERROR.
    IF NOT AVAILABLE Customer THEN 
      FIND LAST Customer.
    UP WITH FRAME cust-frame.
    DISPLAY Customer.CustNum Customer.Name Customer.Address Customer.City 
      WITH FRAME cust-frame.
    NEXT.
  END.

  /* CHOOSE selected a valid key.  Check which key. */
  IF LASTKEY = KEYCODE("c") THEN DO: /* Open a space in the frame. */
    SCROLL FROM-CURRENT DOWN WITH FRAME cust-frame.
    CREATE Customer.
    UPDATE Customer.CustNum Customer.Name Customer.Address Customer.City 
      WITH FRAME cust-frame.
    oldchoice = INPUT Customer.CustNum.
    NEXT.
  END.

  /* Delete a Customer from the database. */
  IF LASTKEY = KEYCODE("d") THEN DO: 
    DELETE Customer.
    REPEAT counter = 1 TO 100 
      WHILE FRAME-LINE(cust-frame) <= FRAME-DOWN(cust-frame).
      FIND NEXT Customer NO-ERROR.
      IF AVAILABLE Customer THEN 
        DISPLAY Customer.CustNum Customer.Name Customer.Address Customer.City 
          WITH FRAME cust-frame.
      ELSE CLEAR FRAME cust-frame.
      DOWN WITH FRAME cust-frame.
    END.
    UP counter - 1 WITH FRAME cust-frame.
    oldchoice = INPUT Customer.CustNum.
  END.
END.
STATUS DEFAULT.
