/* r-opqry.p */

DEFINE QUERY q-order FOR Customer FIELDS(CustNum Name Phone),
  Order FIELDS(OrderNum OrderDate),
  OrderLine FIELDS(LineNum Price Qty),
  Item FIELDS(ItemNum ItemName CatDesc).

OPEN QUERY q-order FOR EACH Customer NO-LOCK,
  EACH Order OF Customer NO-LOCK,
  EACH OrderLine OF Order NO-LOCK,
  EACH Item OF OrderLine NO-LOCK.

GET FIRST q-order.

DO WHILE AVAILABLE Customer:
  DISPLAY Customer.CustNum Customer.Name SKIP
    Customer.Phone SKIP
    Order.OrderNum Order.OrderDate SKIP
    OrderLine.LineNum OrderLine.Price OrderLine.Qty SKIP
    Item.OtemNum Item.ItemName SKIP
    Item.CatDescription VIEW-AS EDITOR SIZE 50 BY 2 SCROLLBAR-VERTICAL
    WITH FRAME ord-info CENTERED SIDE-LABELS TITLE "Order Information".

  /* Allow scrolling, but not modification, of CatDescription. */
  ASSIGN 
    Item.CatDescription:READ-ONLY IN FRAME ord-info = TRUE
    Item.CatDescription:SENSITIVE IN FRAME ord-info = TRUE.
  PAUSE.
  GET NEXT q-order.
END. /* DO WHILE AVAILABLE Customer */ 
