/* r-uidproc.p */

DEFINE VARIABLE hProc AS HANDLE NO-UNDO.
DEFINE VARIABLE hBuf  AS HANDLE NO-UNDO.

DEFINE TEMP-TABLE ttHandles NO-UNDO
  FIELD fHandle AS HANDLE
  FIELD fUID    AS INTEGER
  INDEX ttHandlesIdx IS UNIQUE PRIMARY fHandle.

RUN r-perprc.p PERSISTENT SET hProc NO-ERROR.
RUN manageHandles( hProc ).

/* Continue to use hProc and other handles without the possibility of future conflicts ... */

PROCEDURE manageHandles:
  DEFINE INPUT PARAMETER hNewObject AS HANDLE NO-UNDO.

  FIND ttHandles WHERE fHandle = hNewObject NO-ERROR.
  IF AVAILABLE ttHandles THEN DO:
    IF VALID-HANDLE( fHandle ) THEN
      IF fUID <> hNewObject:UNIQUE-ID THEN DO:
        /* Handles point to different objects; Delete old object and store recycled handle */
        DELETE OBJECT fHandle NO-ERROR.
        fHandle = hNewObject NO-ERROR.
        fUID = hNewObject:UNIQUE-ID No-ERROR.
      END.
      ELSE DO: /* Nothing to do; handles point to the same object */ 
      END.
    ELSE DO: /* fHandle exists, but does not point to a valid object; Replace with recycled handle */
      fHandle = hNewObject NO-ERROR.
      fUID = hNewObject:UNIQUE-ID NO-ERROR.
    END.
  END.
  ELSE DO: /* ttHandles does not yet store this handle; Create new record and store it */
    CREATE ttHandles.
    fHandle = hNewObject NO-ERROR.
    fUID = hNewObject:UNIQUE-ID NO-ERROR.
  END.
END PROCEDURE.
