&ANALYZE-SUSPEND _VERSION-NUMBER AB_v9r12 GUI ADM2
&ANALYZE-RESUME
&Scoped-define WINDOW-NAME wWin
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS wWin 
/*********************************************************************
* Copyright (C) 2000 by Progress Software Corporation ("PSC"),       *
* 14 Oak Park, Bedford, MA 01730, and other contributors as listed   *
* below.  All Rights Reserved.                                       *
*                                                                    *
* The Initial Developer of the Original Code is PSC.  The Original   *
* Code is Progress IDE code released to open source December 1, 2000.*
*                                                                    *
* The contents of this file are subject to the Possenet Public       *
* License Version 1.0 (the "License"); you may not use this file     *
* except in compliance with the License.  A copy of the License is   *
* available as of the date of this notice at                         *
* http://www.possenet.org/license.html                               *
*                                                                    *
* Software distributed under the License is distributed on an "AS IS"*
* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
* should refer to the License for the specific language governing    *
* rights and limitations under the License.                          *
*                                                                    *
* Contributors:                                                      *
*                                                                    *
*********************************************************************/
/*------------------------------------------------------------------------

  File: 

  Description: from cntnrwin.w - ADM SmartWindow Template

  Input Parameters:
      <none>

  Output Parameters:
      <none>

  History: New V9 Version - January 15, 1998
          
------------------------------------------------------------------------*/
/*          This .W file was created with the Progress AB.              */
/*----------------------------------------------------------------------*/

/* Create an unnamed pool to store all the widgets created 
     by this procedure. This is a good default which assures
     that this procedure's triggers and internal procedures 
     will execute in this procedure's storage, and that proper
     cleanup will occur on deletion of the procedure. */

CREATE WIDGET-POOL.

/* ***************************  Definitions  ************************** */

/* Parameters Definitions ---                                           */

/* Local Variable Definitions ---                                       */

DEFINE VARIABLE hWarehouse  AS HANDLE NO-UNDO.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE SmartWindow
&Scoped-define DB-AWARE no

&Scoped-define ADM-CONTAINER WINDOW

/* Name of first Frame and/or Browse and/or first Query                 */
&Scoped-define FRAME-NAME fMain

/* Standard List Definitions                                            */
&Scoped-Define ENABLED-OBJECTS IMAGE-2 RECT-10 lcategory1 btWarehouse 
&Scoped-Define DISPLAYED-OBJECTS lcategory1 

/* Custom List Definitions                                              */
/* List-1,List-2,List-3,List-4,List-5,List-6                            */

/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME



/* ***********************  Control Definitions  ********************** */

/* Define the widget handle for the window                              */
DEFINE VAR wWin AS WIDGET-HANDLE NO-UNDO.

/* Definitions of handles for SmartObjects                              */
DEFINE VARIABLE h_bitem AS HANDLE NO-UNDO.
DEFINE VARIABLE h_ditem AS HANDLE NO-UNDO.
DEFINE VARIABLE h_pupdsav AS HANDLE NO-UNDO.
DEFINE VARIABLE h_vitem AS HANDLE NO-UNDO.

/* Definitions of the field level widgets                               */
DEFINE BUTTON btWarehouse 
     LABEL "Warehouse" 
     SIZE 15 BY 1.12.

DEFINE VARIABLE lcategory1 AS CHARACTER FORMAT "X(25)":U 
     VIEW-AS COMBO-BOX INNER-LINES 5
     SIZE 38 BY 1 NO-UNDO.

DEFINE IMAGE IMAGE-2
     FILENAME "images\s2_banr":U
     SIZE 140.86 BY .96.

DEFINE RECTANGLE RECT-10
     EDGE-PIXELS 2 GRAPHIC-EDGE  NO-FILL 
     SIZE 26 BY 1.62.


/* ************************  Frame Definitions  *********************** */

DEFINE FRAME fMain
     lcategory1 AT ROW 2.42 COL 2 NO-LABEL
     btWarehouse AT ROW 24.42 COL 121
     IMAGE-2 AT ROW 1.23 COL 1
     RECT-10 AT ROW 24.15 COL 115
    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY 
         SIDE-LABELS NO-UNDERLINE THREE-D 
         AT COL 1 ROW 1
         SIZE 140.86 BY 25.04.


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: SmartWindow
   Allow: Basic,Browse,DB-Fields,Query,Smart,Window
   Container Links: Data-Target,Data-Source,Page-Target
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
IF SESSION:DISPLAY-TYPE = "GUI":U THEN
  CREATE WINDOW wWin ASSIGN
         HIDDEN             = YES
         TITLE              = "Item Maintenance"
         HEIGHT             = 25.04
         WIDTH              = 140.86
         MAX-HEIGHT         = 28.81
         MAX-WIDTH          = 146.29
         VIRTUAL-HEIGHT     = 28.81
         VIRTUAL-WIDTH      = 146.29
         RESIZE             = no
         SCROLL-BARS        = no
         STATUS-AREA        = no
         BGCOLOR            = ?
         FGCOLOR            = ?
         THREE-D            = yes
         MESSAGE-AREA       = no
         SENSITIVE          = yes.
ELSE {&WINDOW-NAME} = CURRENT-WINDOW.
/* END WINDOW DEFINITION                                                */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _INCLUDED-LIB wWin 
/* ************************* Included-Libraries *********************** */

{src/adm2/containr.i}

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME




/* ***********  Runtime Attributes and AppBuilder Settings  *********** */

&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES
/* SETTINGS FOR WINDOW wWin
  VISIBLE,,RUN-PERSISTENT                                               */
/* SETTINGS FOR FRAME fMain
                                                                        */
/* SETTINGS FOR COMBO-BOX lcategory1 IN FRAME fMain
   ALIGN-L                                                              */
IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(wWin)
THEN wWin:HIDDEN = yes.

/* _RUN-TIME-ATTRIBUTES-END */
&ANALYZE-RESUME

 



/* ************************  Control Triggers  ************************ */

&Scoped-define SELF-NAME wWin
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL wWin wWin
ON END-ERROR OF wWin /* Item Maintenance */
OR ENDKEY OF {&WINDOW-NAME} ANYWHERE DO:
  /* This case occurs when the user presses the "Esc" key.
     In a persistently run window, just ignore this.  If we did not, the
     application would exit. */
  IF THIS-PROCEDURE:PERSISTENT THEN RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL wWin wWin
ON WINDOW-CLOSE OF wWin /* Item Maintenance */
DO:
  /* This ADM code must be left here in order for the SmartWindow
     and its descendents to terminate properly on exit. */
  APPLY "CLOSE":U TO THIS-PROCEDURE.
  RETURN NO-APPLY.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME btWarehouse
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL btWarehouse wWin
ON CHOOSE OF btWarehouse IN FRAME fMain /* Warehouse */
DO:

  RUN wallocate.w PERSISTENT SET hWarehouse (INPUT h_ditem).
  RUN initializeObject IN hWarehouse.
  
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME lcategory1
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL lcategory1 wWin
ON VALUE-CHANGED OF lcategory1 IN FRAME fMain
DO:
  DEF VAR qhdl AS HANDLE NO-UNDO.
  DEF VAR qrystring AS CHARACTER NO-UNDO.
  DEF VAR ltmpcategory1 LIKE item.category1 NO-UNDO.
  DEF VAR qhdlchar as char NO-UNDO.
  DEF VAR buffhdl as handle NO-UNDO.
  DEF VAR bh as handle NO-UNDO.
  
  IF lcategory1:SCREEN-VALUE = "ALL Categories" THEN ltmpcategory1 = "".
  ELSE ltmpcategory1 = lcategory1:SCREEN-VALUE.

  ASSIGN qhdlchar = DYNAMIC-FUNCTION('getDataHandle':U in h_ditem)
         qhdl = WIDGET-HANDLE(qhdlchar)
         buffhdl = qhdl:get-buffer-handle(1)
         qrystring = " FOR EACH " + buffhdl:name + " WHERE category1 BEGINS '"
          + ltmpcategory1 + "' NO-LOCK By itemnum". 
 
  IF VALID-HANDLE(qhdl) THEN DO: 
      qhdl:QUERY-PREPARE(qrystring).
      qhdl:QUERY-OPEN.
  END. /*valid handle*/
   
  PUBLISH "dataavailable" FROM h_ditem ("Different":U).

END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&UNDEFINE SELF-NAME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK wWin 


/* ***************************  Main Block  *************************** */

/* Include custom  Main Block code for SmartWindows. */
{src/adm2/windowmn.i}

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE adm-create-objects wWin  _ADM-CREATE-OBJECTS
PROCEDURE adm-create-objects :
/*------------------------------------------------------------------------------
  Purpose:     Create handles for all SmartObjects used in this procedure.
               After SmartObjects are initialized, then SmartLinks are added.
  Parameters:  <none>
------------------------------------------------------------------------------*/
  DEFINE VARIABLE currentPage  AS INTEGER NO-UNDO.

  ASSIGN currentPage = getCurrentPage().

  CASE currentPage: 

    WHEN 0 THEN DO:
       RUN constructObject (
             INPUT  'ditem.wDB-AWARE':U ,
             INPUT  FRAME fMain:HANDLE ,
             INPUT  'AppServiceASUsePromptASInfoForeignFieldsRowsToBatch200CheckCurrentChangedyes':U ,
             OUTPUT h_ditem ).
       RUN repositionObject IN h_ditem ( 1.27 , 115.00 ) NO-ERROR.
       /* Size in AB:  ( 1.85 , 10.86 ) */

       RUN constructObject (
             INPUT  'vitem.w':U ,
             INPUT  FRAME fMain:HANDLE ,
             INPUT  'HideOnInitnoDisableOnInitnoObjectLayout':U ,
             OUTPUT h_vitem ).
       RUN repositionObject IN h_vitem ( 2.62 , 42.00 ) NO-ERROR.
       /* Size in AB:  ( 21.42 , 99.00 ) */

       RUN constructObject (
             INPUT  'bitem.w':U ,
             INPUT  FRAME fMain:HANDLE ,
             INPUT  'HideOnInitnoDisableOnInitnoObjectLayout':U ,
             OUTPUT h_bitem ).
       RUN repositionObject IN h_bitem ( 3.62 , 2.00 ) NO-ERROR.
       RUN resizeObject IN h_bitem ( 21.69 , 38.00 ) NO-ERROR.

       RUN constructObject (
             INPUT  'adm2/pupdsav.r':U ,
             INPUT  FRAME fMain:HANDLE ,
             INPUT  'AddFunctionOne-RecordEdgePixels2PanelTypeSaveHideOnInitnoDisableOnInitnoObjectLayout':U ,
             OUTPUT h_pupdsav ).
       RUN repositionObject IN h_pupdsav ( 24.12 , 42.00 ) NO-ERROR.
       RUN resizeObject IN h_pupdsav ( 1.77 , 72.00 ) NO-ERROR.

       /* Links to SmartDataObject h_ditem. */
       RUN addLink ( h_vitem , 'Update':U , h_ditem ).

       /* Links to SmartDataViewer h_vitem. */
       RUN addLink ( h_ditem , 'Data':U , h_vitem ).
       RUN addLink ( h_pupdsav , 'TableIO':U , h_vitem ).

       /* Links to SmartDataBrowser h_bitem. */
       RUN addLink ( h_ditem , 'Data':U , h_bitem ).

       /* Adjust the tab order of the smart objects. */
       RUN adjustTabOrder ( h_vitem ,
             lcategory1:HANDLE IN FRAME fMain , 'AFTER':U ).
       RUN adjustTabOrder ( h_bitem ,
             h_vitem , 'AFTER':U ).
       RUN adjustTabOrder ( h_pupdsav ,
             h_bitem , 'AFTER':U ).
    END. /* Page 0 */

  END CASE.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI wWin  _DEFAULT-DISABLE
PROCEDURE disable_UI :
/*------------------------------------------------------------------------------
  Purpose:     DISABLE the User Interface
  Parameters:  <none>
  Notes:       Here we clean-up the user-interface by deleting
               dynamic widgets we have created and/or hide 
               frames.  This procedure is usually called when
               we are ready to "clean-up" after running.
------------------------------------------------------------------------------*/
  /* Delete the WINDOW we created */
  IF SESSION:DISPLAY-TYPE = "GUI":U AND VALID-HANDLE(wWin)
  THEN DELETE WIDGET wWin.
  IF THIS-PROCEDURE:PERSISTENT THEN DELETE PROCEDURE THIS-PROCEDURE.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI wWin  _DEFAULT-ENABLE
PROCEDURE enable_UI :
/*------------------------------------------------------------------------------
  Purpose:     ENABLE the User Interface
  Parameters:  <none>
  Notes:       Here we display/view/enable the widgets in the
               user-interface.  In addition, OPEN all queries
               associated with each FRAME and BROWSE.
               These statements here are based on the "Other 
               Settings" section of the widget Property Sheets.
------------------------------------------------------------------------------*/
  DISPLAY lcategory1 
      WITH FRAME fMain IN WINDOW wWin.
  ENABLE IMAGE-2 RECT-10 lcategory1 btWarehouse 
      WITH FRAME fMain IN WINDOW wWin.
  {&OPEN-BROWSERS-IN-QUERY-fMain}
  VIEW wWin.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE exitObject wWin 
PROCEDURE exitObject :
/*------------------------------------------------------------------------------
  Purpose:  Window-specific override of this procedure which destroys 
            its contents and itself.
    Notes:  
------------------------------------------------------------------------------*/

  APPLY "CLOSE":U TO THIS-PROCEDURE.
  RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE initializeObject wWin 
PROCEDURE initializeObject :
/*------------------------------------------------------------------------------
  Purpose:     Super Override
  Parameters:  
  Notes:       
------------------------------------------------------------------------------*/

  /* Code placed here will execute PRIOR to standard behavior. */
 DEF VAR ok AS LOGICAL NO-UNDO.

     DO WITH FRAME {&FRAME-NAME}:  
          ok = lcategory1:ADD-FIRST("All Categories").  

          FOR EACH item NO-LOCK BREAK BY category1:
              IF FIRST-OF(category1) THEN
              ok = lcategory1:ADD-LAST(item.category1).  
          END. /* for each item*/
          
          lcategory1:SCREEN-VALUE = "All Categories".
                              
     END. /*do with frame {&frame-name}*/ 



  RUN SUPER.

  /* Code placed here will execute AFTER standard behavior.    */

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

