/* e-outcust.p - Export the Customer table to an xml file*/
DEFINE VARIABLE hDoc   AS HANDLE  NO-UNDO.
DEFINE VARIABLE hRoot  AS HANDLE  NO-UNDO.
DEFINE VARIABLE hRow   AS HANDLE  NO-UNDO.
DEFINE VARIABLE hField AS HANDLE  NO-UNDO.
DEFINE VARIABLE hText  AS HANDLE  NO-UNDO.
DEFINE VARIABLE hBuf   AS HANDLE  NO-UNDO.
DEFINE VARIABLE hDBFld AS HANDLE  NO-UNDO.
DEFINE VARIABLE ix     AS INTEGER NO-UNDO.

CREATE X-DOCUMENT hDoc.
CREATE X-NODEREF hRoot.
CREATE X-NODEREF hRow.
CREATE X-NODEREF hField.
CREATE X-NODEREF hText.

hBuf = BUFFER customer:HANDLE.

/* Set up a root node */
hDoc:CREATE-NODE(hRoot, "Customers", "ELEMENT").
hDoc:APPEND-CHILD(hRoot).

FOR EACH Customer NO-LOCK WHERE Customer.CustNum < 5:
  /* Create a customer row node */
  hDoc:CREATE-NODE(hRow, "Customer", "ELEMENT").
  hRoot:APPEND-CHILD(hRow).  /*put the row in the tree*/
  hRow:SET-ATTRIBUTE("CustNum", STRING(Customer.CustNum)).
  hRow:SET-ATTRIBUTE("Name", Customer.Name).

  /* Add the other fields as tags in the xml */
  REPEAT ix = 1 TO hBuf:NUM-FIELDS:
    hDBFld = hBuf:BUFFER-FIELD(ix).
    IF hDBFld:NAME = "CustNum" OR  hDBFld:NAME = "Name" THEN NEXT.
    /* Create a tag with the field name */
    hDoc:CREATE-NODE(hField, hDBFld:NAME, "ELEMENT").
    hRow:APPEND-CHILD(hField).            /* Put the new field as next child of row */
    hDoc:CREATE-NODE(hText, "", "TEXT").  /* Add a node to hold field value */
    hField:APPEND-CHILD(hText).           /* Attach the text to the field */
    hText:NODE-VALUE = STRING(hDBFld:BUFFER-VALUE).
  END.
END.

/* Write the XML node tree to an xml file */
hDoc:SAVE("file", "cust.xml").

DELETE OBJECT hDoc.
DELETE OBJECT hRoot.
DELETE OBJECT hRow.
DELETE OBJECT hField.
DELETE OBJECT hText.
