/* pi-tfx-read-8.p */
/* Populates an empty dynamic ProDataSet with XML Schema and records 
   from an XML document. */
  
{pi-tfx-parameterVarDefs.i}

DEFINE VARIABLE hQuery      AS HANDLE  NO-UNDO.
DEFINE VARIABLE hPDS        AS HANDLE  NO-UNDO.
DEFINE VARIABLE returnValue AS LOGICAL NO-UNDO.

CREATE DATASET hPDS.

ASSIGN
  cSourceType             = "FILE"
  cFile                   = "Dept400-2.xml" 
  cReadMode               = "EMPTY"
  cSchemaLocation         = "Dept400-2.xsd"
  lOverrideDefaultMapping = ?
  cFieldTypeMapping       = ?
  cVerifySchemaMode       = ?.
 
returnValue = hPDS:READ-XML(cSourceType, cFile, cReadMode, cSchemaLocation,
                            lOverrideDefaultMapping, cFieldTypeMapping,
                            cVerifySchemaMode).

IF returnValue THEN
  DISPLAY SKIP 
    "How many temp-table buffers in the ProDataSet?" hPDS:NUM-BUFFERS SKIP
    "How many data-relations in the ProDataSet?" hPDS:NUM-RELATIONS SKIP(1).

  CREATE QUERY hQuery.
  hQuery:SET-BUFFERS(hPDS:GET-BUFFER-HANDLE("ttEmp")).
  hQuery:QUERY-PREPARE("FOR EACH ttEmp").
  hQuery:QUERY-OPEN().
  hQuery:GET-FIRST().

  DISPLAY 
    "Displaying Employee Roster..." SKIP(1)
    "Employee No.  Last Name        First Name".

  REPEAT WHILE NOT hQuery:QUERY-OFF-END:
    DISPLAY 
      hPDS:GET-BUFFER-HANDLE("ttEmp"):BUFFER-FIELD("EmpNum"):BUFFER-VALUE
      hPDS:GET-BUFFER-HANDLE("ttEmp"):BUFFER-FIELD("LastName"):BUFFER-VALUE 
      hPDS:GET-BUFFER-HANDLE("ttEmp"):BUFFER-FIELD("FirstName"):BUFFER-VALUE.
    hQuery:GET-NEXT().
END.
