/* pi-tfx-ttSetup-6.i */
/* Creates a dynamic temp-table, creates a handle for the temp-table's 
   default buffer, and creates two new records for the temp-table, */

DEFINE VARIABLE httCust  AS HANDLE NO-UNDO.
DEFINE VARIABLE httbCust AS HANDLE NO-UNDO.

CREATE TEMP-TABLE httCust.
httCust:CREATE-LIKE("Customer").
httCust:TEMP-TABLE-PREPARE("ttCust").

/* The default buffer handle of a dynamic temp-table is more flexible than the
   handle of the dynamic temp-table, so it is more commonly used. However, you 
   can access the READ-XML method from the dynamic temp-table handle. */
httbCust = httCust:DEFAULT-BUFFER-HANDLE. 
httbCust:BUFFER-CREATE().

ASSIGN
  httbCust:BUFFER-FIELD("Name"):BUFFER-VALUE     = "Extreme XML Sports"
  httbCust:BUFFER-FIELD("CustNum"):BUFFER-VALUE  = 1
  httbCust:BUFFER-FIELD("Balance"):BUFFER-VALUE  = 111.11
  httbCust:BUFFER-FIELD("Country"):BUFFER-VALUE  = "USA"
  httbCust:BUFFER-FIELD("Comments"):BUFFER-VALUE = "Enthusiastic new customer!".

httbCust:BUFFER-CREATE().

ASSIGN 
  httbCust:BUFFER-FIELD("Name"):BUFFER-VALUE     = "Low-Impact XML Sports"
  httbCust:BUFFER-FIELD("CustNum"):BUFFER-VALUE  = 4
  httbCust:BUFFER-FIELD("Balance"):BUFFER-VALUE  = 444.44
  httbCust:BUFFER-FIELD("Country"):BUFFER-VALUE  = "USA"
  httbCust:BUFFER-FIELD("Comments"):BUFFER-VALUE = "Mellow new customer.".
