/* pi-tfx-ttSetup-11.i */
/* Define a ProDataSet and temp-table buffers that use multiple namespaces. */

DEFINE TEMP-TABLE ttDept NO-UNDO 
  NAMESPACE-URI "urn:Dept-Temp-Table" NAMESPACE-PREFIX "pfxDept" 
  FIELD DeptCode LIKE department.DeptCode
  FIELD DeptName LIKE department.DeptName.

DEFINE TEMP-TABLE ttEmp  NO-UNDO 
  NAMESPACE-URI "urn:Emp-Temp-Table"  NAMESPACE-PREFIX "pfxEmp" 
  FIELD DeptCode LIKE employee.DeptCode
  FIELD EmpNum LIKE employee.EmpNum
  FIELD LastName LIKE employee.LastName
  FIELD FirstName LIKE employee.FirstName
  FIELD Address LIKE employee.Address
  FIELD Address2 LIKE employee.Address2
  FIELD City LIKE employee.City
  FIELD State LIKE employee.State
  FIELD PostalCode LIKE employee.PostalCode.

DEFINE TEMP-TABLE ttFam NO-UNDO
  NAMESPACE-URI "urn:Fam-Temp-Table" NAMESPACE-PREFIX "pfxFam"  
  FIELD EmpNum LIKE family.EmpNum
  FIELD RelativeName LIKE family.RelativeName
  FIELD Relation LIKE family.Relation
  FIELD CoveredOnBenefits LIKE family.CoveredOnBenefits.

DEFINE DATASET dsEmployees 
  NAMESPACE-URI "urn:PRODATASET" NAMESPACE-PREFIX "pfxDS"
  FOR ttDept, ttEmp, ttFam 
  DATA-RELATION DeptEmp FOR ttDept, ttEmp   
    RELATION-FIELDS(deptcode, deptcode) NESTED
  DATA-RELATION EmpFam FOR ttEmp, ttFam     
    RELATION-FIELDS (empnum,empnum) NESTED.

DEFINE DATA-SOURCE dsDept FOR Department.
DEFINE DATA-SOURCE dsEmp  FOR Employee.
DEFINE DATA-SOURCE dsFam  FOR Family.

/* Attach the data-sources to the ProDataSet buffers */
BUFFER ttDept:handle:ATTACH-DATA-SOURCE(DATA-SOURCE dsDept:HANDLE,?,?,?).
BUFFER ttEmp:handle:ATTACH-DATA-SOURCE(DATA-SOURCE dsEmp:HANDLE,?,?,?).
BUFFER ttFam:HANDLE:ATTACH-DATA-SOURCE(DATA-SOURCE dsFam:HANDLE,?,?,?).

DEFINE VARIABLE returnValue AS LOGICAL.

DATA-SOURCE dsDept:FILL-WHERE-STRING = "WHERE Department.DeptCode = '400'".
DATA-SOURCE dsEmp:FILL-WHERE-STRING = "WHERE Employee.EmpNum = 3".
returnValue = DATASET dsEmployees:FILL().
