/* pi-tfx-writeSetup-4.i */
/* Definition of a ProDataSet. */

DEFINE TEMP-TABLE ttDept
  FIELD DeptCode LIKE Department.DeptCode
  FIELD DeptName LIKE Department.DeptName
  INDEX DeptCode IS PRIMARY UNIQUE DeptCode.

DEFINE TEMP-TABLE ttEmp
  FIELD DeptCode LIKE Employee.DeptCode
  FIELD EmpNum LIKE Employee.EmpNum
  FIELD LastName LIKE Employee.LastName
  FIELD FirstName LIKE Employee.FirstName
  FIELD Address LIKE Employee.Address
  FIELD Address2 LIKE Employee.Address2
  FIELD City LIKE Employee.City
  FIELD State LIKE Employee.State
  FIELD PostalCode LIKE Employee.PostalCode
  FIELD HomePhone LIKE Employee.HomePhone
  FIELD WorkPhone LIKE Employee.WorkPhone
  FIELD Position LIKE Employee.Position
  FIELD Birthdate LIKE Employee.Birthdate
  FIELD StartDate LIKE Employee.StartDate
  FIELD VacationDaysLeft LIKE Employee.VacationDaysLeft
  FIELD SickDaysLeft LIKE Employee.SickDaysLeft
  INDEX EmpNo IS PRIMARY UNIQUE EmpNum
  INDEX DeptCode DeptCode
  INDEX Name IS UNIQUE LastName FirstName.

DEFINE TEMP-TABLE ttFam
  FIELD EmpNum LIKE Family.EmpNum
  FIELD RelativeName LIKE Family.RelativeName
  FIELD Relation LIKE Family.Relation
  FIELD Birthdate LIKE Family.Birthdate
  FIELD CoveredOnBenefits LIKE Family.CoveredOnBenefits
  FIELD BenefitDate LIKE Family.BenefitDate
  INDEX EmpNoRelativeName IS PRIMARY UNIQUE EmpNum RelativeName.
    
DEFINE TEMP-TABLE ttBene
  FIELD EmpNum LIKE Benefits.EmpNum
  FIELD HealthCare LIKE Benefits.HealthCare
  FIELD LifeInsurance LIKE Benefits.LifeInsurance
  FIELD Pension401K LIKE Benefits.Pension401K
  FIELD StockPurchase LIKE Benefits.StockPurchase
  FIELD MedicalSpending LIKE Benefits.MedicalSpending
  FIELD DependentCare LIKE Benefits.DependentCare
  INDEX EmpNo IS PRIMARY UNIQUE EmpNum.
 
DEFINE DATASET DSET FOR ttDept, ttEmp, ttFam, ttBene
  DATA-RELATION DeptEmp FOR ttDept, ttEmp 
    RELATION-FIELDS(deptcode, deptcode) NESTED
  DATA-RELATION EmpFam FOR ttEmp, ttFam 
    RELATION-FIELDS (empnum,empnum) NESTED
  DATA-RELATION EmpBene FOR ttEmp,ttBene 
    RELATION-FIELDS (empnum,empnum) NESTED.
 
DEFINE DATA-SOURCE dsDept FOR Department.
DEFINE DATA-SOURCE dsEmp  FOR Employee.
DEFINE DATA-SOURCE dsBene FOR Benefits.
DEFINE DATA-SOURCE dsFam  FOR Family.
 
BUFFER ttDept:handle:ATTACH-DATA-SOURCE(DATA-SOURCE dsDept:HANDLE).
BUFFER ttEmp:handle:ATTACH-DATA-SOURCE(DATA-SOURCE dsEmp:HANDLE).
BUFFER ttBene:handle:ATTACH-DATA-SOURCE(DATA-SOURCE dsBene:HANDLE).
BUFFER ttFam:HANDLE:ATTACH-DATA-SOURCE(DATA-SOURCE dsFam:HANDLE).
 
DATA-SOURCE dsDept:FILL-WHERE-STRING = "Where DeptCode = '400' ".
DATASET DSET:FILL().
