/* sax-envelope-2.p - Program to write an envelope address */
DEFINE VARIABLE hSAXWriter AS HANDLE NO-UNDO.

CREATE SAX-WRITER hSAXWriter.
hSAXWriter:FORMATTED = TRUE. /* Format output so it is easy to read */
hSAXWriter:SET-OUTPUT-DESTINATION("file", "mailing.xml").

hSAXWriter:START-DOCUMENT().
/* The ENCODING attribute defaults to UTF-8 */
/* The FRAGMENT attribute defaults to FALSE */
/* The STRICT   attribute defaults to TRUE  */

hSAXWriter:START-ELEMENT("psc:mailingaddress").
hSAXWriter:DECLARE-NAMESPACE("www.progress.com", "psc").
hSAXWriter:WRITE-DATA-ELEMENT("psc:name", "John Smith").

hSAXWriter:START-ELEMENT("psc:address"). 
hSAXWriter:INSERT-ATTRIBUTE("type", "personal"). /* Node has an attribute */
hSAXWriter:WRITE-DATA-ELEMENT("psc:street",  "411 Whatsup St.").
hSAXWriter:WRITE-DATA-ELEMENT("psc:city",    "Somerville").
hSAXWriter:WRITE-DATA-ELEMENT("psc:state",   "MA").
hSAXWriter:WRITE-DATA-ELEMENT("psc:zipcode", "02143").
hSAXWriter:END-ELEMENT("psc:address").

hSAXWriter:START-ELEMENT("psc:address"). 
hSAXWriter:INSERT-ATTRIBUTE("type", "business"). /* Node has an attribute */
hSAXWriter:WRITE-DATA-ELEMENT("psc:name",   "Progress Software").
hSAXWriter:WRITE-DATA-ELEMENT("psc:street", "14 Oak Park").
hSAXWriter:WRITE-DATA-ELEMENT("psc:city",   "Bedford").
hSAXWriter:WRITE-DATA-ELEMENT("psc:state",  "MA").
hSAXWriter:WRITE-DATA-ELEMENT("psc:zip",    "01730").
hSAXWriter:END-ELEMENT("psc:address").

hSAXWriter:WRITE-EMPTY-ELEMENT("psc:default").
hSAXWriter:INSERT-ATTRIBUTE("type", "personal").

hSAXWriter:END-ELEMENT("psc:mailingaddress").
hSAXWriter:END-DOCUMENT(). /* Document written to working directory. */
