 
 /*------------------------------------------------------------------------
    File        : HelpButton
    Purpose     : 
    Syntax      : 
    Description : 
    Author(s)   : pjudge
    Created     : Thu Jul 31 13:12:08 EDT 2008
    Notes       : 
  ----------------------------------------------------------------------*/

USING Progress.Lang.*.
USING System.Windows.Forms.*.
using openedge.tutorial.ui.*.

CLASS openedge.tutorial.ui.HelpButton INHERITS Button :
    
    define public property ParentControl as Control no-undo
        get. set. 
    	
	DEFINE PRIVATE VARIABLE components AS System.ComponentModel.IContainer.

	CONSTRUCTOR PUBLIC HelpButton (  ):
		
		SUPER().
		InitializeComponent ( ).

	END CONSTRUCTOR.

	METHOD PRIVATE VOID InitializeComponent ( ):

     /* 		NOTE: The following method is generated by the OpenEdge Advanced GUI Visual Designer.
     
             We strongly suggest that the contents of this method only be modified using the
             Visual Designer to avoid any incompatible modifications.
     
             Modifying the contents of this method using a code editor will invalidate any support for this file. */
		THIS-OBJECT:SuspendLayout().
		/*  */
		/* HelpButton */
		/*  */
		THIS-OBJECT:BackgroundImageLayout = System.Windows.Forms.ImageLayout:None.
		THIS-OBJECT:Font = NEW System.Drawing.Font("Microsoft Sans Serif", 16, System.Drawing.FontStyle:Bold, System.Drawing.GraphicsUnit:Point, Progress.Util.CastUtil:ToByte(0)).
		THIS-OBJECT:Size = NEW System.Drawing.Size(23, 23).
		THIS-OBJECT:Text = "Help".
		THIS-OBJECT:UseVisualStyleBackColor = FALSE.
		THIS-OBJECT:Click:SUBSCRIBE(THIS-OBJECT:OnClick).
		THIS-OBJECT:ResumeLayout(FALSE).
	END METHOD.

    METHOD PRIVATE VOID OnClick (sender AS System.Object, e AS System.EventArgs):
        ShowHelp().    
        
	END METHOD.
	
	method private void ShowHelp ():
	    def var cFilename as char no-undo.
	    def var cKeyword as character no-undo.
	    def var cTopicIdentifier as character no-undo.	    
	    def var helpNavigator as HelpNavigator no-undo.
	    def var lWorks as logical no-undo init False.
	    
	    /* callback to parent to get help info */
	    if type-of(ParentControl, IHelpCallback) then
        do:
            /* Try getting the context in order of increasing 
               granularity. The GetHelpContext() call will throw
               an error if it's not in use. */
            lWorks = cast(ParentControl, IHelpCallback):GetHelpContext (output cFilename,
                                                                        output helpNavigator,
                                                                        output cTopicIdentifier).
            if lWorks then
            do:            
                Help:ShowHelp(ParentControl, cFilename, helpNavigator, cTopicIdentifier).
                leave.
            end.                
                                                               
            lWorks = cast(ParentControl, IHelpCallback):GetHelpContext (output cFilename,
                                                                        output helpNavigator).
            if lWorks then
            do:
                Help:ShowHelp(ParentControl, cFilename, helpNavigator).                                                                        
                leave.
            end.                

            lWorks = cast(ParentControl, IHelpCallback):GetHelpContext (output cFilename, cKeyword).
            if lWorks then
            do:
                Help:ShowHelp(ParentControl, cFilename, cKeyword).
                leave.
            end.                

            lWorks = cast(ParentControl, IHelpCallback):GetHelpContext (output cFilename).
            if lWorks then
            do:
                Help:ShowHelp(ParentControl, cFilename).
                leave.
            end.                
        end.    /* help callback */
    end method.

	DESTRUCTOR PUBLIC HelpButton ( ):

		IF VALID-OBJECT(components) THEN DO:
			CAST(components, System.IDisposable):Dispose().
		END.

	END DESTRUCTOR.

END CLASS.